# Generated by Makefile. Do not edit.

commit ec95f91e686f270a93a4f9a6a15c73c8eb3df8c6
Merge: 3ae04f1 ceb72c7
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Tue Nov 1 18:15:43 2016 +0100

    Merge pull request #156 from bluca/rel
    
    Problem: need to tag a new release

commit ceb72c7e0666f63f6b3d4e411d218fc8876f7e7c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Nov 1 15:58:34 2016 +0000

    Finalize NEWS and bump ABI to 5:2:0 for 4.1.6

 NEWS         | 2 +-
 configure.ac | 3 ++-
 2 files changed, 3 insertions(+), 2 deletions(-)

commit b41ef3963b98c6a8edc29b7ff7e3fb634e37ae90
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Nov 1 15:53:56 2016 +0000

    Problem: spec file hard codes .so version
    
    Solution: use wildcard instead

 builds/redhat/zeromq.spec.in | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 3ae04f1d3e2a66be7eff7aa57a838afad74fadc9
Merge: 21e4847 fb1ee2b
Author: Doron Somech <somdoron@gmail.com>
Date:   Tue Nov 1 16:48:14 2016 +0200

    Merge pull request #155 from bluca/alignment
    
    Problem: pointer union for zmq_msg_t is a hack

commit fb1ee2b078af0f0a6f7bcbac12be2a26b0512ce4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Nov 1 13:02:59 2016 +0000

    Update NEWS for #1325

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit f2de03a48005834aa7ac3df76ea973f3e0af7a92
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Oct 28 16:31:48 2016 +0100

    Problem: MS VC++ build broken
    
    Solution: try to detect architecture if building with VC++ and
    hardcode pointer size accordingly.
    Expressions are not allowed inside declspec intrinsics, which
    includes other intrinsics.

 include/zmq.h | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit a077adb4a0e9fdd8f96f5eee12a6613c134090f7
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Nov 1 13:00:05 2016 +0000

    Problem: pointer union for zmq_msg_t is a hack
    
    Solution: use compiler's alignment attributes instead which is
    clearer and less of a hack.
    Pointer alignment violations causing crashes on architectures
    such as sparc64 and aarch64.
    This also avoid triggering ABI checkers as the change is compatible
    even though applications that suffer from the bug should rebuild to
    take advantage of the fix.

 include/zmq.h | 17 ++++++++++++++---
 1 file changed, 14 insertions(+), 3 deletions(-)

commit 21e484750e4c13e81597bbb4cf6d178ef05e8631
Merge: 7302228 dc68d2e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Oct 23 20:25:47 2016 +0100

    Merge pull request #154 from vielmetti/patch-1
    
    Update INSTALL to note issues with parallel "make -j check"

commit dc68d2ef4581f3cab6cebcf46a479b0ab933c88b
Author: Edward Vielmetti <edward.vielmetti@gmail.com>
Date:   Sun Oct 23 15:21:57 2016 -0400

    Update INSTALL to note issues with parallel "make -j check"
    
    Documentation also patched in libzmq.
    
    Closes #151 to document non-support for parallel make check.

 INSTALL | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 7302228026871045590778c85fe9ddc84983707a
Merge: ff8b0aa 56611dd
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Oct 21 12:40:22 2016 +0100

    Merge pull request #153 from jens-auer/2158
    
    Fixed function prototypes

commit 56611dd46bd1d1ded57e64ecec9989b0d122d8ac
Author: Jens Auer <jens.auer@betaversion.net>
Date:   Fri Oct 21 12:27:32 2016 +0200

    Fixed function prototypes

 src/socket_base.hpp | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit ff8b0aa6eca447452a173a161aa9d873965edcac
Merge: cd3680d 5e20710
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Thu Oct 13 13:13:58 2016 +0200

    Merge pull request #150 from bluca/news
    
    Problem: NEWS out of date

commit 5e207100f57b4434bc5fdf6be95ed0588365d6c4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Oct 13 10:48:14 2016 +0100

    Problem: NEWS out of date
    
    Solution: mention recently backported fixes

 NEWS | 4 ++++
 1 file changed, 4 insertions(+)

commit cd3680d178a0f4ce4f6b5a9971d7790b5de5bbb4
Merge: 107266b 798532e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Oct 13 10:37:50 2016 +0100

    Merge pull request #148 from jens-auer/backport-#1649
    
    Merged PR 1649

commit 107266b77d8fc79f1d4bcb1f73d3c79a2f9269c8
Merge: 5ea5629 7aec4be
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Oct 13 10:37:37 2016 +0100

    Merge pull request #149 from jens-auer/2158
    
    Add mutex to socket monitor access

commit 798532e0c5ec386cdee015eba2a8c3cb6de5ff16
Author: Jens Auer <jens.auer@cgi.com>
Date:   Tue Oct 11 12:26:24 2016 +0000

    Merged PR 1649
    
    https://github.com/zeromq/libzmq/pull/1649/commits

 src/pipe.cpp              | 11 ++-----
 tests/test_hwm_pubsub.cpp | 77 +++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 80 insertions(+), 8 deletions(-)

commit 7aec4be368558d7f920dd864fc420477e97fbe9e
Author: Jens Auer <jens.auer@cgi.com>
Date:   Tue Oct 11 12:24:55 2016 +0000

    Add mutex to socket monitor access
    
    The monitor socket is used concurrently from different threads
    and needs protection.

 src/socket_base.cpp | 66 +++++++++++++++++++++++++++++++----------------------
 src/socket_base.hpp | 11 +++++----
 2 files changed, 46 insertions(+), 31 deletions(-)

commit 5ea56294517b20b3b935687d41ab9dc366e9ec4b
Merge: 44c1d81 064a8b6
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 3 23:54:30 2016 +0100

    Merge pull request #147 from WGH-/doc-router-mandatory-block
    
    doc/zmq_socket.txt: clarify that ROUTER can be blocking

commit 064a8b676604d5e5e2d7b94356991749a5e8fe2c
Author: WGH <wgh@torlan.ru>
Date:   Tue Oct 4 00:37:50 2016 +0300

    doc/zmq_socket.txt: clarify that ROUTER can be blocking
    
    Problem: zmq_socket doc doesn't mention that router can block on send
    
    Solution: clarify that it may block, and under which conditions

 doc/zmq_socket.txt | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 44c1d81506a42a3f2adad414092b284389f5502a
Merge: 89cf62b 05f1912
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Sat Sep 24 21:33:05 2016 +0200

    Merge pull request #146 from bluca/dealer_router_async
    
    Problem: zmq_ctx_term asserts with connect-before-bind and sockets with identity over inproc transport

commit 05f1912b63f58ad3525d9b2dc0fae21a3994c04d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 24 19:58:35 2016 +0100

    Problem: Travis CI OSX builds are broken
    
    Solution: add a workaround to reinstall libtool. Travis hasn't fixed
    the issue in a month, so time for a little hack until they sort it.

 .travis.yml | 4 ++++
 1 file changed, 4 insertions(+)

commit 0527673982105ace35c1b78ac81a649009fcfcc5
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 24 19:47:33 2016 +0100

    Update NEWS for #2117

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit d38a2d507d7cfe0d0c30933c374612be566a33ba
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 24 18:07:23 2016 +0100

    Problem: zmq_ctx_term asserts with connect-before-bind and sockets with identity over inproc transport
    
    Solution: check if the connecting inproc socket has been closed
    before trying to send the identity.
    Otherwise the pipe will be in waiting_for_delimiter state causing
    writes to fail and the connect to assert when the context is being
    torn down and the pending inproc connects are resolved.
    Add test case that covers this behaviour.

 src/ctx.cpp                   |  8 +++++++-
 tests/test_inproc_connect.cpp | 25 +++++++++++++++++++++++++
 2 files changed, 32 insertions(+), 1 deletion(-)

commit 89cf62b977873d175606375020c4c09fde91840f
Merge: 7d11efa 1a51f72
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Sat Sep 17 21:35:56 2016 +0200

    Merge pull request #145 from bluca/ipv6_multi_endpoint
    
    Problem: zmq_connect with IPv6 "source:port;dest:port" format is broken

commit 1a51f726a8cbbccccb5799162a1850a95b46ede5
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 17 20:01:35 2016 +0100

    Update NEWS for #2107

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit acab1f487bfaca026715c19cb2816c0cc1e60f7f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 17 19:18:09 2016 +0100

    Problem: zmq_connect with IPv6 "source:port;dest:port" format is broken
    
    Solution: allow for '[' character when doing the basic sanity check
    on the TCP endpoint.
    Also add unit tests for both IPv4 and IPv6 source;dest format.

 src/socket_base.cpp       | 2 +-
 tests/test_reqrep_tcp.cpp | 8 ++++----
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 8ddf198256a2ca83eca57df4f47cdb14e42d8b1f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 17 19:08:53 2016 +0100

    Problem: test_reqrep_tcp does not have IPv6 tests
    
    Solution: add them

 tests/test_reqrep_tcp.cpp | 130 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 130 insertions(+)

commit 67d60b1909958ceb16615962251de6651dbfe7ca
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 17 18:55:25 2016 +0100

    Problem: test_reqrep_tcp does not test multiple endpoints
    
    Solution: add a test for this use case

 tests/test_reqrep_tcp.cpp | 71 +++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 71 insertions(+)

commit 9c350937822ce408b31037709742e1faf11c64f8
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 17 18:51:11 2016 +0100

    Problem: test_reqrep_tcp does not test disconnect/unbind
    
    Solution: add disconnect and unbind calls to the test

 tests/test_reqrep_tcp.cpp | 6 ++++++
 1 file changed, 6 insertions(+)

commit 7bc7395a2ad1fef1f17cff4294533c6d4d631874
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 17 18:46:21 2016 +0100

    Problem: test_reqrep_tcp is too limited
    
    Solution: refactor it to allow for multiple functionalities to be
    tested

 tests/test_reqrep_tcp.cpp | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

commit 7d11efa0e2797922f60972e82a4c5e93f35b5193
Merge: 3f791bb f942303
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Sep 14 16:16:24 2016 +0100

    Merge pull request #144 from kou/support-mingw-cross-compile
    
    Support cross compile with MinGW on Linux

commit f942303cd54966cfc50f7c1a4be78560c17f0987
Author: Kouhei Sutou <kou@clear-code.com>
Date:   Wed Sep 14 23:28:46 2016 +0900

    Support cross compile with MinGW on Linux
    
    Linux uses case sensitive file system. So we can't find "wincrypt.h" by
    "WinCrypt.h".

 tweetnacl/contrib/randombytes/winrandom.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3f791bb92b417491ae67b26a25e20e787bed2651
Merge: aac9e54 60162b5
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Fri Sep 2 10:16:46 2016 +0200

    Merge pull request #141 from bluca/cmake_dist
    
    Problem: CMake build from dist tarball broken

commit 60162b52262bbb43b226493bce6d83cd309c7823
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Sep 1 13:29:13 2016 +0100

    Update NEWS for #2096

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit e00b2c4b082cf74628e26f719ebb98bc8e5b553f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Sep 1 13:23:09 2016 +0100

    Problem: CMake build from dist tarball broken
    
    Solution: include src/version.rc.in and tests/CMakeLists.txt in the
    make dist tarball by adding them to makefile.am EXTRA_DIST list.

 Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit aac9e54f8d9377be2c4dddc5cfc0ca36ab32d19f
Merge: a6d24d7 2268009
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Sat Aug 27 18:31:54 2016 +0200

    Merge pull request #140 from bluca/xp_testutils_ipv6
    
    Problem: testutil.hpp fails to build on Windows XP

commit 22680094ca76cd1fa570d4009e57aa4d7e602348
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Aug 27 17:15:58 2016 +0100

    Update NEWS for #2091

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 328fe0994651f660fefa208f1767572955cf6946
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Aug 27 16:40:43 2016 +0100

    Problem: testutil.hpp fails to build on Windows XP
    
    Solution: ifdef is_ipv6_available to always return false if building
    on Windows XP, as it doesn't support the needed standard libc
    functions

 tests/testutil.hpp | 4 ++++
 1 file changed, 4 insertions(+)

commit a6d24d7fd890153bb5a4bb294a7c82fa5d67a68f
Merge: aab1edf 2b7b903
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Aug 26 11:37:40 2016 +0100

    Merge pull request #137 from gcv/master
    
    Fix alignment problem with zmq_msg_t

commit aab1edfd7d9fc8e993be68e9128994c35ff3d273
Merge: 4732951 b86717d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Aug 22 20:34:25 2016 +0100

    Merge pull request #139 from t-b/bugfix/fix_compilation_on_windows
    
    Fix compilation on windows

commit b86717dc9a5d83e05644b9e301f60746483a8897
Author: Thomas Braun <thomas.braun@byte-physics.de>
Date:   Mon Aug 22 20:57:28 2016 +0200

    Tests: Fix compilation on Windows
    
    Visual Studio 2015 does grok the preprocessor defintion.
    Add an explicit call to defined as done in other places.

 tests/test_security_curve.cpp | 2 +-
 tests/test_security_null.cpp  | 2 +-
 tests/test_security_plain.cpp | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 64dbf56d6ef17e0bc6bb1a193f70bf9252638b82
Author: Thomas Braun <thomas.braun@byte-physics.de>
Date:   Mon Aug 22 20:57:01 2016 +0200

    testutil.hpp: Fix include path to windows.hpp

 tests/testutil.hpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2b7b903a854a4b8f8bfc62a852a8e9a3d306296c
Author: Constantine Vetoshev <vetoshev@gmail.com>
Date:   Tue Aug 16 13:31:46 2016 -0700

    Fix alignment problem with zmq_msg_t.
    
    Problem occurs on SPARC and ARM CPUs. This commit is a backport of
    https://github.com/zeromq/libzmq/commit/d9fb1d36ff2008966af538f722a1f4ab158dbf64 (from
    libzmq), first reported in https://github.com/zeromq/libzmq/issues/1325.

 include/zmq.h | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 4732951d05911f03f0c8273309732ace8b101a71
Merge: 61b8f1a 727178f
Author: Doron Somech <somdoron@gmail.com>
Date:   Tue Aug 16 11:47:56 2016 +0300

    Merge pull request #136 from GreatFruitOmsk/master
    
    Backport fix libzmq #2084

commit 727178f1acb6c06733cfde369f9d4e68ae97edb8
Author: Ilya Kulakov <kulakov.ilya@gmail.com>
Date:   Tue Aug 16 00:59:42 2016 -0700

    Backport fix libzmq #2084

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 61b8f1a4241fdb4fe17e54c2920fc230d4bb4de1
Merge: 53c7bcf 888b1f8
Author: Kevin Sapper <sappo@users.noreply.github.com>
Date:   Tue Jul 26 06:34:39 2016 +0000

    Merge pull request #134 from bluca/news
    
    Problem: NEWS out of date

commit 888b1f8649b7a991f86b859604bdda2911339e0a
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Jul 21 10:15:55 2016 +0100

    Update NEWS to mention fixed issue 2051

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 53c7bcfa5fa4722ef0e774c1f2ea44b18250e3d4
Merge: e8116b1 565892f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Jul 20 23:24:24 2016 +0100

    Merge pull request #133 from garlick/issue_2051
    
    Problem: getifaddrs can fail with ECONNREFUSED

commit 565892f3cd71b65f097f748321832e7003a3d9a0
Author: Jim Garlick <garlick.jim@gmail.com>
Date:   Wed Jul 20 10:15:55 2016 -0700

    Problem: getifaddrs can fail with ECONNREFUSED
    
    getifaddrs() can fail transiently with ECONNREFUSED on Linux.
    This has been observed with Linux 3.10 when multiple processes
    call zmq::tcp_address_t::resolve_nic_name() simultaneously.
    
    Before asserting in this case, make 10 attempts, with exponential
    backoff, given by (1 msec * 2^i), where i is the attempt number.
    
    Fixes #2051

 src/tcp_address.cpp | 11 ++++++++++-
 1 file changed, 10 insertions(+), 1 deletion(-)

commit e8116b1f1ce90bb98d327833548b364c24b80365
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Jun 17 12:41:42 2016 +0100

    Bump version to 4.1.6 for next release

 NEWS          | 4 ++++
 include/zmq.h | 2 +-
 2 files changed, 5 insertions(+), 1 deletion(-)

commit c5bd2870c2eaa3fd12f4c53367a3c9a0fd14fe85
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Jun 17 12:05:57 2016 +0100

    Finalize NEWS and bump ABI to 5:1:0 for 4.1.5

 NEWS                         | 2 +-
 builds/redhat/zeromq.spec.in | 2 +-
 configure.ac                 | 3 ++-
 3 files changed, 4 insertions(+), 3 deletions(-)

commit 2ef080588aa733f36474fae984cf85a735c64ad5
Merge: b849af4 7a8a83b
Author: Kevin Sapper <sappo@users.noreply.github.com>
Date:   Sat Jun 4 18:32:48 2016 +0200

    Merge pull request #127 from bluca/fix_deploy
    
    Problem: Travis deploy token is wrong

commit 7a8a83ba84a0c82806314e18466844222fc0c538
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jun 4 17:29:25 2016 +0200

    Problem: Travis deploy token is wrong
    
    Solution: encrypt it wit the right parameter and fix it

 .travis.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b849af44c55175179d8aaeb0e9dc23123c717a4e
Merge: 7d540d6 3f7c3c2
Author: Kevin Sapper <sappo@users.noreply.github.com>
Date:   Sat Jun 4 16:46:16 2016 +0200

    Merge pull request #126 from bluca/distcheck
    
    Problem: make distcheck is broken and deploying release artifacts is a manual process

commit 3f7c3c2658986cab620c986a6d2995a96b56697b
Author: Kevin Sapper <mail@kevinsapper.de>
Date:   Wed May 4 22:05:40 2016 +0200

    Problem: Deploying release artifacts is a manual process Solution: Use travis to deploy these artifacts automatically.
    
    The deployment is triggered by tagging on the zeromq/libzmq repository.
    Of the many builds travis is checking only the default one with
    libsodium and drafts disabled is used for deployment.
    
    For now the results of `make distcheck` are deployed as well as their
    md5 and sha1 hash sums. Further changes may upload a generated
    Changelog as well.

 .travis.yml  | 16 ++++++++++++++++
 ci_deploy.sh | 20 ++++++++++++++++++++
 2 files changed, 36 insertions(+)

commit 81a68d73dddedddf3a383608d1b2547cf7d93702
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jun 4 13:01:41 2016 +0200

    Problem: Travis CI does not run make distcheck
    
    Solution: do it

 .travis.yml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6c1851efdbd72919c9b9ac0480b08f58d60c8d6a
Author: Pieter Hintjens <ph@imatix.com>
Date:   Sat Jun 4 15:58:13 2016 +0200

    Problem: autotools platform.hpp is not compatible with CMake
    
    Specifically, the poller detection code does not set macros in
    platform.hpp. The configure script passed them as -D on the command
    line.
    
    Solution: rewrite the poller detection code.

 acinclude.m4 | 211 ++++++++++++++++++++++++++++-------------------------------
 configure.ac |   8 ++-
 2 files changed, 104 insertions(+), 115 deletions(-)

commit 83bf40ee1fbca75631149d9d1510ebd9c8e7fb92
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jun 4 15:39:43 2016 +0200

    Update NEWS for fix #2021

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 7d540d6dfeacede3c1bf5919802343ebb771b1ff
Merge: 330c682 d0b2239
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jun 4 14:34:41 2016 +0100

    Merge pull request #125 from wbx-github/master
    
    allow to build sparc (v8,leon)

commit 330c68240389d88a52c154a699bb1981f3cacd78
Merge: 4d613cb 1b06a50
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jun 4 10:28:56 2016 +0100

    Merge pull request #124 from aburgm/issue-1542
    
    Backport fix for issue 1542 to zmq 4.1.x

commit 4d613cb8901a969146f158a4884c401edbdc7159
Merge: 56b71af ca69183
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jun 4 10:28:12 2016 +0100

    Merge pull request #122 from pijyoi/master
    
    fix: sockets are not signed int on Windows

commit d0b22397ebbef8e250c4cad25b8686018804aa15
Author: Waldemar Brodkorb <wbx@uclibc-ng.org>
Date:   Sat Jun 4 09:30:49 2016 +0200

    allow to build sparc (v8,leon)
    
    Only set sparcv9 optimization for sparc64 systems.
    This allows to run for example application using zeromq
    on sparc32 systems.
    
    Signed-off-by: Waldemar Brodkorb <wbx@uclibc-ng.org>

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1b06a5025d8a8c6b1f0b2abd3402f96ac6ac1cfb
Author: Armin Burgmeier <armin@arbur.net>
Date:   Fri Jun 3 20:41:04 2016 -0700

    Update NEWS to mention fixed issue 1542

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 783fb45f9dd47196ec6c82ac7c7821deb1e1031c
Author: Matt Bolger <matt.bolger@csiro.au>
Date:   Fri Aug 21 13:45:59 2015 +1000

    -Set signaler_port to 0 which allows the OS to find a free port, rather than crashing if 5905 is in use (https://github.com/zeromq/libzmq/issues/1542)
    -Added config.hpp to the source list so it shows up in generated projects
    -Remove CMAKE_BUILD_TYPE setting for generators that don't use it

 CMakeLists.txt | 7 +++++--
 src/config.hpp | 6 +++++-
 2 files changed, 10 insertions(+), 3 deletions(-)

commit ca691835927292f015a6854450b3492bd41959e2
Author: KIU Shueng Chuan <nixchuan@gmail.com>
Date:   Sun May 8 16:29:15 2016 +0800

    fix: sockets are not signed int on Windows

 src/tcp_connecter.cpp | 2 +-
 src/tcp_listener.cpp  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 56b71af22db3232eb57fd72e954e22eeac497b46
Merge: 3ad076a 6bbc6b6
Author: Pieter Hintjens <ph@imatix.com>
Date:   Wed May 4 12:46:47 2016 +0200

    Merge pull request #121 from bluca/builds_make_dist
    
    Problem: missing files in release tarballs

commit 6bbc6b67f651eb10a9baaa246f63ae32e8bfb1c3
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed May 4 11:26:43 2016 +0100

    Update NEWS for fix #1952

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit c369d9bd36a4d6ac416f53095fb7ad77cd10b27a
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Mar 6 18:32:30 2016 +0000

    Problem: doc/Makefile.am ignores --without-docs
    
    Solution: add the document files to the MAN_DOC and MAN_HTML targets
    in doc/Makefile.am only if BUILD_DOC and INSTALL_MAN are set,
    otherwise leave the targets empty to avoid errors in make distcheck.

 doc/Makefile.am | 10 +++++++---
 1 file changed, 7 insertions(+), 3 deletions(-)

commit 4dd6257d9316b44134b4ef4070249531d1a83e77
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Aug 10 12:25:19 2015 +0200

    Problem: source packages lack makefiles for all systems except msvc
    
    Solution: specify the necessary EXTRA_DIST
    
    I added a Makefile.am in builds that covers all systems except msvc,
    which already has a Makefile.am that does this.
    
    Fixes #1505

 Makefile.am        |  2 +-
 builds/Makefile.am | 26 ++++++++++++++++++++++++++
 configure.ac       |  1 +
 3 files changed, 28 insertions(+), 1 deletion(-)

commit 3ad076a7a3e79fbe9c6dd6dc4bdd75d4e6c7b77f
Merge: b315d61 81c9c49
Author: Min RK <benjaminrk@gmail.com>
Date:   Thu Apr 21 12:03:17 2016 +0200

    Merge pull request #118 from bluca/zmq_unbind_api_breakage
    
    Problem: can't unbind with bound addr with IPv6

commit 81c9c498eefb450a9d7a35a56cb995943b8394b7
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Apr 18 18:13:45 2016 +0100

    Update NEWS for fix #114

 NEWS | 3 +++
 1 file changed, 3 insertions(+)

commit 0af39a443f39c1a0bb5d7d60ca8667b4e33599f4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Apr 18 00:02:36 2016 +0100

    Problem: can't unbind with bound addr with IPv6
    
    Solution: try to resolve the TCP endpoint passed by the user in the
    zmq_unbind call before giving up, if it doesn't match.
    This fixes a breakage in the API, where after a call to
    zmq_bind(s, "tcp://127.0.0.1:9999") with IPv6 enabled on s would
    result in the call to zmq_unbind(s, "tcp://127.0.0.1:9999") failing.
    Add more test cases to increase coverage on all combinations of TCP
    endpoints.

 src/socket_base.cpp            |  32 +++++-
 tests/test_unbind_wildcard.cpp | 228 +++++++++++++++++++++++++++++++++++++++++
 2 files changed, 259 insertions(+), 1 deletion(-)

commit 1586f3f25ebb4b479e4334eccb551634425bcb0f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Apr 18 17:12:01 2016 +0100

    Problem: can't test if IPv6 is available in tests
    
    Solution: add helper function is_ipv6_available to testutil.hpp to
    test if IPv6 is available on the building platform.
    This function will try to open and bind a socket to ::1:*, as it's
    the ultimate way of knowing if, at least on the loopback, IPv6 is
    enabled.

 tests/testutil.hpp | 52 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 52 insertions(+)

commit b315d610b804bad5637ea31cdfced30da2dddd0f
Merge: dd077bc 2018743
Author: Pieter Hintjens <ph@imatix.com>
Date:   Wed Apr 20 19:12:30 2016 +0200

    Merge pull request #119 from hitstergtd/fix-NEWS-for-pr-1877
    
    Problem: No NEWS entry for Issue #919

commit 2018743b4e980513b8ac70f8fb2e9d6579260e23
Author: hitstergtd <hitstergtd@users.noreply.github.com>
Date:   Wed Apr 20 08:59:43 2016 +0100

    Problem: No NEWS entry for Issue #919
    
    Solution: add entry and mark it as related to Issue #1877 and PR #1511

 NEWS | 1 +
 1 file changed, 1 insertion(+)

commit dd077bc2b2db192ee6abe41f8070817fed9c7990
Merge: 7105025 e488df7
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Wed Apr 13 22:56:53 2016 +0200

    Merge pull request #117 from bluca/solaris_fixes
    
    Problem: build broken on Solaris 10

commit e488df7892dda78564c7086bee0c10dd6d4ad88d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Apr 13 00:22:22 2016 +0100

    Update NEWS for fix #1866

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 02d71a88ab0794799a40f8d08240d73028176815
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Apr 13 00:05:26 2016 +0100

    Problem: missing () after sizeof cause build fail
    
    Solution: use sizeof () to avoid build failure on Solaris 10 with
    gcc 3.4

 src/tcp_address.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b2eddf9746c58b0a870a90f0d57dea03fce5b06a
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Apr 12 23:53:17 2016 +0100

    Problem: -lssp causes build failure on Solaris
    
    Solution: add -lssp on Solaris only when libsodium is enabled and has
    been found. Also disable pedantic and Werror, as libsodium headers
    use pragma diagnostic which are not available in gcc 3.4.

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3945f27f6d4fd7bcc803ff4a36fc5db239ce2eac
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Apr 12 23:52:34 2016 +0100

    Problem: pragma diagnostic is new in GCC 4.2
    
    Solution: check for GCC version before using pragma diagnostic
    in tweetnacl to avoid an additional warning.

 tweetnacl/contrib/randombytes/randombytes.h | 2 +-
 tweetnacl/src/tweetnacl_base.h              | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 71050259f7c8aa343e62866a10e757f75c6b5184
Merge: 197a9e0 6d92d26
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Thu Apr 7 18:30:13 2016 +0200

    Merge pull request #116 from bluca/ipv6_downgrade

commit 6d92d263e13fd00c5170274f8dd4ab92d8324cb5
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Apr 7 17:10:52 2016 +0100

    Update NEWS for fix #1887

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 1a1abe3d5eacd3aa8bc50219383f532e39c080b6
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Apr 7 13:17:08 2016 +0100

    Problem: redundant Windows errno conversion
    
    Solution: in the Windows-specific ifdef in tcp_listener set_address,
    check for error and set errno only after the IPv4 fallback has failed
    too, to avoid setting errno when the socket creation succeeds through
    the fallback.

 src/tcp_listener.cpp | 4 ----
 1 file changed, 4 deletions(-)

commit 1e87d9252782423885f569a789714966c237b61f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Apr 7 13:15:41 2016 +0100

    Problem: zmq_connect (TCP) has no IPv4 fallback
    
    Solution: if opening an IPv6 TCP socket fails because IPv6 is not
    available, try to open an IPv4 socket instead when creating and
    connecting a TCP endpoint.

 src/tcp_connecter.cpp | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 82aed1dee6c5ea8ce122c20712b9778b656ee9e6
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Apr 6 17:15:39 2016 +0100

    Problem: zmq_bind IPv4 fallback still tries IPv6
    
    Solution: if opening an IPv6 TCP socket fails because IPv6 is not
    available, try to open an IPv4 socket instead when creating and
    binding a TCP endpoint.

 src/tcp_listener.cpp | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 197a9e05e2322059edf1fa1be752b530efe40362
Merge: d873292 cf0dcd2
Author: Pieter Hintjens <ph@imatix.com>
Date:   Wed Mar 30 19:41:34 2016 +0200

    Merge pull request #115 from bluca/linger_fix_backport
    
    Problem: connection might terminate prematurely

commit cf0dcd237926affc7cb154143f7e0170ffd5fb3d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Mar 30 17:05:21 2016 +0100

    Problem: NEWS not up to date with bug fixes
    
    Solution: mention closing issue #1877

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit bf92026527a11667670cfe1f04c8308333f4982c
Author: Soren Hansen <Soren.Hansen@ril.com>
Date:   Thu Aug 6 20:09:37 2015 +0200

    Avoid terminating connections prematurely
    
    While sending very large messages (far beyond what fits in a the tcp
    buffer, so it takes multiple sendto system calls for it to finish),
    zmq_close will close the connection regardless of ZMQ_LINGER.
    
    In case no engine is attached, a pipe->check_read() is needed to look
    for the delimiter in the pipe and ultimately trigger the pipe
    termination.
    
    However, if there *is* an engine attached, the check_read() looks ahead
    and finds the delimiter and terminates the connection even though the
    engine might actually still be in the middle of sending a message.
    
    This happens because while the io_thread is still busy sending the data,
    the pipe can get terminated and the io thread ends up being terminated.

 src/session_base.cpp | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit d8732929d507d59dd8d877d35a81308d4ddb1e71
Merge: e0041f1 bbe4f3e
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Tue Mar 15 07:02:50 2016 +0100

    Merge pull request #112 from hintjens/master

commit bbe4f3ede45f242b495f151922ab5a86a89f80de
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Mar 15 06:26:34 2016 +0100

    Problem: does not build on Windows with libsodium
    
    Solution: fixed wrong condition around randombytes_close ().

 src/ctx.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e0041f1fcbf5b335945efbcc37ea36fad16a29ce
Merge: 5aa7bdf 9883459
Author: Constantin Rack <c-rack@users.noreply.github.com>
Date:   Sat Mar 12 20:52:29 2016 +0100

    Merge pull request #111 from hintjens/master
    
    Problem: cannot disable encryption if libsodium is installed

commit 98834596f1b70659ab6f47880dd61d402ba186e0
Author: Pieter Hintjens <ph@imatix.com>
Date:   Sat Mar 12 15:26:26 2016 +0100

    Problem: cannot disable encryption if libsodium is installed
    
    The sodium/tweetnacl detection logic does not yet you disable
    encryption if libsodium is installed.
    
    Fixes #1850 in libzmq/master

 CMakeLists.txt                              | 64 ++++++++++++++---------
 Makefile.am                                 |  2 +-
 NEWS                                        |  2 +
 configure.ac                                | 79 ++++++++++++++---------------
 src/ctx.cpp                                 | 10 ++--
 src/curve_client.cpp                        |  4 +-
 src/curve_client.hpp                        | 16 +++---
 src/curve_server.cpp                        |  4 +-
 src/curve_server.hpp                        | 16 +++---
 src/options.cpp                             |  8 +--
 src/stream_engine.cpp                       |  2 +-
 src/zmq.cpp                                 |  2 +-
 src/zmq_utils.cpp                           | 17 +++----
 tests/test_capabilities.cpp                 |  2 +-
 tests/test_security_curve.cpp               |  4 +-
 tweetnacl/contrib/randombytes/randombytes.h | 10 ++++
 tweetnacl/src/tweetnacl_base.h              | 10 ++++
 17 files changed, 142 insertions(+), 110 deletions(-)

commit 5aa7bdfc68514ae2bb0a3423040ce5388aef32c5
Merge: c1d8420 25be170
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Mar 1 17:05:52 2016 +0100

    Merge pull request #109 from hintjens/master
    
    Updated news for fix #1831

commit 25be170b57db3cf7689093608269904d639def7d
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Mar 1 17:05:22 2016 +0100

    Updated news for fix #1831

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit c1d8420335b5d70e23fed3da53638323a2c96492
Merge: 4985b08 58badc4
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Mar 1 17:05:10 2016 +0100

    Merge pull request #108 from hintjens/master
    
    Problem: can't be sure crypto_box always returns 0

commit 58badc44c12a4fd976b2a7c5cb8f0b1bbd0f6249
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Mar 1 15:01:23 2016 +0100

    Problem: can't be sure crypto_box always returns 0
    
    Libsodium has started returning -1 in some cases.
    
    Solution: allow and handle error returns from these calls.
    
    Fixes #1831

 src/curve_client.cpp          | 10 ++++++----
 src/curve_server.cpp          |  3 ++-
 tests/test_security_curve.cpp |  2 +-
 3 files changed, 9 insertions(+), 6 deletions(-)

commit 4985b084e67dca8765ad940797f3fa5af6a6e66c
Merge: 0b781f8 2fba10d
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Feb 29 21:38:54 2016 +0100

    Merge pull request #107 from grimbeaver/fix-vs-versions
    
    Update VS version resource and package version.

commit 2fba10d691495651f293e18212ff76636849d3a3
Author: Thomas Brezinski <tbrezins@gmail.com>
Date:   Mon Feb 29 13:32:07 2016 -0600

    Update VS version resource and package version.

 builds/msvc/resource.rc        | Bin 4642 -> 4642 bytes
 packaging/nuget/package.config |   2 +-
 2 files changed, 1 insertion(+), 1 deletion(-)

commit 0b781f84e8a93796a3902bd5ec2828391e9e2bd1
Merge: 4d45ee9 b1a150a
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Feb 16 15:05:39 2016 +0100

    Merge pull request #104 from bluca/uninitialised_news
    
    Problem: news out of date

commit b1a150a6751547188b22eb822954b561851d1366
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Feb 16 14:04:10 2016 +0000

    Problem: my name is not in the AUTHORS file
    
    Solution: add myself to the list

 AUTHORS | 1 +
 1 file changed, 1 insertion(+)

commit 5977a8a5b6c12d46658a6dbc08efa8bbcd0ba9e4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Feb 16 14:02:30 2016 +0000

    Problem: NEWS not up to date with bug fixes
    
    Solution: mention issues 1806 and 1807

 NEWS | 4 ++++
 1 file changed, 4 insertions(+)

commit 4d45ee94408724c5b5a41a93849240ca7435b266
Merge: cb811a1 eda5426
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Feb 16 14:51:29 2016 +0100

    Merge pull request #103 from bluca/uninitialised_sockopt
    
    Problem: curve keys getsockopt uninitialised read

commit eda5426865a6035d564f1a1f8af67c64b38a8f6e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Feb 16 13:41:46 2016 +0000

    Problem: Travis CI uses libsodium unstable branch
    
    Solution: use stable branch instead of the development branch, and
    also clone with --depth 1 to make it more efficient.

 .travis.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6a66c051798332fbbf0fbffe09ff914746ece41f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Feb 16 13:27:09 2016 +0000

    Problem: curve keys getsockopt uninitialised read
    
    Solution: always initialised zmq::options_t class variables arrays to
    avoid reading uninitialised data when CURVE is not yet configured and
    a getsockopt ZMQ_CURVE_{SERVER | PUBLIC | SECRET]KEY is issued.
    
    Backport from libzmq.

 src/options.cpp | 3 +++
 1 file changed, 3 insertions(+)

commit cb811a1e0caa2b3d5e849e7095fd9e5cd9172699
Merge: b624f1a 87dd037
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Feb 16 12:03:11 2016 +0100

    Merge pull request #102 from hintjens/master
    
    Backported fix #1608

commit 87dd03750bf7ce0f8926e6d757b62604f7f952e9
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Feb 16 12:02:26 2016 +0100

    Updated NEWS for fix #1608

 NEWS | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 4cee2896972f35a11d004bd2a842f774e0a6b747
Author: Pieter Hintjens <ph@imatix.com>
Date:   Sun Nov 1 12:57:32 2015 +0100

    Problem: Windows 7 TCP slow start
    
    See issue #1608.
    
    This is an old issue with Windows 7. The effect is that we see a latency
    ramp on the first 500 messages.
    
    * The ramp is unaffected by message size.
    * Sleeping up to 100msec between sends has no effect except to switch
        off ZeroMQ batching so making the ramp more visible.
    * After 500 messages, latency falls back down to ~10-40 usec.
    * Over inproc:// the ramp happens when we use the signaler class.
    * Client-server over inproc:// does not show the ramp.
    * Client-server over tcp:// shows a similar ramp.
    
    We know that the signaller is using TCP on Windows. We can 'prime' the
    connection by doing 500 dummy sends. This potentially causes new sockets
    to be delayed on creation, which is not a good solution.
    
    Note that the signaller sends zero-byte messages. This may also be
    confusing TCP.
    
    Solution: flood the receive buffer when creating a new FD pair; send a
    1M buffer and discard it.
    
    Fixes #1608

 src/signaler.cpp | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit b624f1adc913f669010b519f80d7c92947285efb
Merge: b341dd7 4959315
Author: Pieter Hintjens <ph@imatix.com>
Date:   Fri Feb 12 23:17:22 2016 +0100

    Merge pull request #101 from bluca/gcc6
    
    Problem: build broken with gcc 6

commit 49593151db3a53b99b69d4afa8be3112eead6b93
Author: meox <glmeocci@gmail.com>
Date:   Fri Feb 12 21:57:51 2016 +0000

    [PATCH] fix error with gcc 5.2

 src/zmq.cpp | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit b341dd7ffe15354012427bcfe7c8a88edccc603b
Merge: ad7fe55 2058dec
Author: Pieter Hintjens <ph@imatix.com>
Date:   Fri Feb 12 13:45:12 2016 +0100

    Merge pull request #100 from CommanderBubble/master
    
    compilation fixes for when _WIN32_WINNT >= 0x0600

commit 2058dece7727ea97d8fc40286b1450a43a1fa49b
Author: Michael <CommanderBubble@users.noreply.github.com>
Date:   Fri Feb 12 23:36:48 2016 +1100

    added windows.hpp with include check
    
    windows.hpp must be included before zmq.h when _WIN32_WINNT >= 0x0600

 src/poller.hpp | 4 ++++
 1 file changed, 4 insertions(+)

commit 45404f4b06238ad679f8e360ce48ee20171b16ad
Author: Michael <CommanderBubble@users.noreply.github.com>
Date:   Fri Feb 12 23:36:07 2016 +1100

    added windows.hpp with include check
    
    windows.hpp must be included before zmq.h when _WIN32_WINNT >= 0x0600

 src/msg.cpp | 6 ++++++
 1 file changed, 6 insertions(+)

commit 6f4e9f13f3716c233add54f1121015fe358cbb1e
Author: Michael <CommanderBubble@users.noreply.github.com>
Date:   Fri Feb 12 23:34:43 2016 +1100

    changed order of includes
    
    windows.hpp must be included before zmq.h when _WIN32_WINNT >= 0x0600

 src/err.hpp | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit af3b9452a2026092d3abdaaca0ffbd2ea1e26369
Author: Michael <CommanderBubble@users.noreply.github.com>
Date:   Fri Feb 12 23:33:22 2016 +1100

    remove include that is already in header

 src/err.cpp | 1 -
 1 file changed, 1 deletion(-)

commit 626abbdaf2c325df665073d6ce7510d9f17f7c7a
Author: Michael <CommanderBubble@users.noreply.github.com>
Date:   Fri Feb 12 23:32:20 2016 +1100

    update for mingw's default _WIN32_WINNT
    
    mingw defaults with _WIN32_WINNT as 0x0502 which doesn't define inet_pton(), so add a conditional check

 tests/test_security_plain.cpp | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit d0b341cf0fd59a3eb8809d4e6515857b30b28647
Author: Michael <CommanderBubble@users.noreply.github.com>
Date:   Fri Feb 12 23:31:55 2016 +1100

    update for mingw's default _WIN32_WINNT
    
    mingw defaults with _WIN32_WINNT as 0x0502 which doesn't define inet_pton(), so add a conditional check

 tests/test_security_null.cpp | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 41cc603d11588f76ba244ae77e8ed500833ad844
Author: Michael <CommanderBubble@users.noreply.github.com>
Date:   Fri Feb 12 23:31:24 2016 +1100

    update for mingw's default _WIN32_WINNT
    
    mingw defaults with _WIN32_WINNT as 0x0502 which doesn't define inet_pton(), so add a conditional check

 tests/test_security_curve.cpp | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit ad7fe55e95ddf6a352990b3b71f99a927ed0f5b6
Merge: b539733 e68c2d2
Author: Pieter Hintjens <ph@imatix.com>
Date:   Thu Feb 11 14:16:39 2016 +0100

    Merge pull request #98 from zeromq/revert-95-patch-1
    
    Revert "update minimum _WIN32_WINNT version to 0x0600 for 4.1.4 onwards"

commit e68c2d25632c25fab0d988a25108f362bd674145
Author: Min RK <benjaminrk@gmail.com>
Date:   Thu Feb 11 14:00:41 2016 +0100

    Revert "update minimum _WIN32_WINNT version to 0x0600 for 4.1.4 onwards"

 src/windows.hpp | 11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

commit b539733cee0f47f9bf1a70dc7cb7ff20410d3380
Merge: 58ac365 3ae84e6
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Feb 8 13:01:12 2016 +0100

    Merge pull request #97 from minrk/configure-tweetnacl
    
    support tweetnacl in configure

commit 3ae84e6b00108ad6aed21faf22a08ae8faded56a
Author: Min RK <benjaminrk@gmail.com>
Date:   Mon Feb 8 11:58:30 2016 +0100

    fallback on tweetnacl if libsodium is not found and not explicitly requested

 configure.ac | 26 ++++++++++++++++++++------
 1 file changed, 20 insertions(+), 6 deletions(-)

commit 6f022cce929e55df1e71ca89351e209f9cdcfa1b
Author: Min RK <benjaminrk@gmail.com>
Date:   Mon Feb 8 11:40:50 2016 +0100

    add --with-tweetnacl to configure
    
    allows building with tweetnacl without cmake

 Makefile.am  |  9 +++++++++
 configure.ac | 11 +++++++++++
 2 files changed, 20 insertions(+)

commit 58ac36593fe43b634a4b79cc3e4b565296aa1bad
Merge: 5501f19 e3fba7d
Author: Pieter Hintjens <ph@imatix.com>
Date:   Tue Feb 2 14:17:48 2016 +0100

    Merge pull request #95 from CommanderBubble/patch-1
    
    update minimum _WIN32_WINNT version to 0x0600 for 4.1.4 onwards

commit e3fba7d447cc6826ed1b235e69156b9670ba0ef8
Author: Michael <CommanderBubble@users.noreply.github.com>
Date:   Tue Feb 2 22:32:16 2016 +1100

    updated minimum _WIN32_WINNT version to 0x0600
    
    if_nametoindex requires minimum windows version vista, which is 0x0600

 src/windows.hpp | 11 ++++-------
 1 file changed, 4 insertions(+), 7 deletions(-)

commit 5501f19a0f4c596c5247c743c04759ef075927d3
Author: Pieter Hintjens <ph@imatix.com>
Date:   Thu Jan 21 18:04:09 2016 +0100

    Update NEWS

 NEWS | 1 +
 1 file changed, 1 insertion(+)

commit 9bdfb949990e4ace7aeae29b2fc190340caa5206
Merge: 802c2a8 0c5c536
Author: Pieter Hintjens <ph@imatix.com>
Date:   Thu Jan 21 18:03:03 2016 +0100

    Merge pull request #93 from GreatFruitOmsk/master
    
    Backport zeromq/libzmq#1723

commit 0c5c536303d0baf67a7c6ccebb0c7c92ee2c56c7
Author: Ilya Kulakov <kulakov.ilya@gmail.com>
Date:   Thu Jan 21 19:56:23 2016 +0600

    Backport zeromq/libzmq#1723

 src/tcp_address.cpp | 35 +++++++++++++++++++++++++++--------
 1 file changed, 27 insertions(+), 8 deletions(-)

commit 802c2a8a2bd1871b557817199af73d2896bf449c
Merge: b7a3097 4788c7d
Author: Pieter Hintjens <ph@imatix.com>
Date:   Thu Jan 21 08:58:23 2016 +0100

    Merge pull request #92 from GreatFruitOmsk/master
    
    Backport zeromq/libzmq#1722

commit 4788c7d2a9e98520615e5e0ee6a996dfe86a304e
Author: Ilya Kulakov <kulakov.ilya@gmail.com>
Date:   Thu Jan 21 13:45:42 2016 +0600

    Backport zeromq/libzmq#1722

 src/socket_base.cpp | 1 +
 1 file changed, 1 insertion(+)

commit b7a30978cae343d061983e00e8b2c713b66fc5a9
Merge: c7642aa d1a0baf
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Jan 18 15:53:16 2016 +0100

    Merge pull request #91 from minrk/backport-winrandom-backwards
    
    backport winrandom fix

commit d1a0baf25fc8251778ba6465c333bb82cd3150ab
Author: Anonymous Maarten <anonymous.maarten@gmail.com>
Date:   Sun Oct 25 03:43:24 2015 +0100

    tweetNaCL: fix winrandom
    
    problem: random byte generation on windows got stuck in an infinite loop
    solution: the failure test is incorrect. Change it

 tweetnacl/contrib/randombytes/winrandom.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c7642aa434138232aad8d3caa02d38d734c75b11
Merge: 7689bc3 795a7e3
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Jan 18 13:05:29 2016 +0100

    Merge pull request #90 from hintjens/master
    
    Reverted patch for IPv6 support

commit 795a7e3de23dd99852d68437c02048dfbbd3c865
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Jan 18 13:04:00 2016 +0100

    Revert "Fix missing include for if_nametoindex on Windows."
    
    This reverts commit b9dbc5b8caea5491c7330d891e93e2791d84c906.

 src/windows.hpp | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 95766dd09ca47e5d5994fb9ac69fe9c1d6968446
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Jan 18 13:03:49 2016 +0100

    Revert "Add missing support for IPv6 link local addresses (which include % followed by the interface name)"
    
    This reverts commit 849e5b07d982e7c0917a13d9ff22d447817dd7fe.

 src/socket_base.cpp |  6 ++----
 src/tcp_address.cpp | 26 ++------------------------
 2 files changed, 4 insertions(+), 28 deletions(-)

commit 7689bc30b964c7f885f47396f328d933598b9b4c
Merge: e809507 0f684ac
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Jan 18 12:47:33 2016 +0100

    Merge pull request #89 from minrk/stdint.h
    
    don't include stdint.h on msc < 1600

commit 0f684ac16c18ada5553c219423ba977753365e40
Author: Min RK <benjaminrk@gmail.com>
Date:   Mon Jan 18 12:30:05 2016 +0100

    don't include stdint.h on msc < 1600
    
    where stdint.h is unavailable
    
    (see stdint.hpp for the same check)

 include/zmq.h | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit e8095071d91f870131a6e53de650d628e709db3b
Merge: 6933dff f13d4f1
Author: Pieter Hintjens <ph@imatix.com>
Date:   Mon Jan 18 11:14:08 2016 +0100

    Merge pull request #88 from minrk/tweetnacl
    
    tweetnacl in sdists

commit f13d4f1d04c8dd1c99e8ef94e5952dd174c6ff9d
Author: Min RK <benjaminrk@gmail.com>
Date:   Mon Jan 18 10:39:37 2016 +0100

    add windows randombytes implementation
    
    backport zeromq/libzmq#1619

 .gitignore                                       |  148 +++
 .hgeol                                           |    2 +
 .travis.yml                                      |   35 +
 AUTHORS                                          |  138 +++
 CMakeLists.txt                                   |  862 ++++++++++++++
 COPYING                                          |  674 +++++++++++
 COPYING.LESSER                                   |  181 +++
 Dockerfile                                       |   11 +
 INSTALL                                          |  246 ++++
 MAINTAINERS                                      |   56 +
 Makefile.am                                      |  638 ++++++++++
 NEWS                                             | 1066 +++++++++++++++++
 README.md                                        |   55 +
 acinclude.m4                                     |  930 +++++++++++++++
 autogen.sh                                       |   49 +
 branding.bmp                                     |  Bin 0 -> 25818 bytes
 builds/cmake/Modules/FindAsciiDoc.cmake          |   27 +
 builds/cmake/Modules/TestZMQVersion.cmake        |    9 +
 builds/cmake/Modules/ZMQSourceRunChecks.cmake    |  129 +++
 builds/cmake/NSIS.template32.in                  |  952 +++++++++++++++
 builds/cmake/NSIS.template64.in                  |  960 +++++++++++++++
 builds/cmake/platform.hpp.in                     |   90 ++
 builds/mingw32/Makefile.mingw32                  |   47 +
 builds/mingw32/platform.hpp                      |   41 +
 builds/msvc/Makefile.am                          |  103 ++
 builds/msvc/build/buildall.bat                   |   10 +
 builds/msvc/build/buildbase.bat                  |   69 ++
 builds/msvc/errno.cpp                            |   32 +
 builds/msvc/errno.hpp                            |   56 +
 builds/msvc/platform.hpp                         |   41 +
 builds/msvc/properties/Common.props              |   21 +
 builds/msvc/properties/DLL.props                 |   16 +
 builds/msvc/properties/Debug.props               |   29 +
 builds/msvc/properties/DebugDEXE.props           |   21 +
 builds/msvc/properties/DebugDLL.props            |   20 +
 builds/msvc/properties/DebugLEXE.props           |   20 +
 builds/msvc/properties/DebugLIB.props            |   21 +
 builds/msvc/properties/DebugLTCG.props           |   20 +
 builds/msvc/properties/DebugSEXE.props           |   21 +
 builds/msvc/properties/EXE.props                 |   17 +
 builds/msvc/properties/LIB.props                 |   16 +
 builds/msvc/properties/LTCG.props                |   13 +
 builds/msvc/properties/Link.props                |   21 +
 builds/msvc/properties/Messages.props            |   15 +
 builds/msvc/properties/Output.props              |   30 +
 builds/msvc/properties/Release.props             |   41 +
 builds/msvc/properties/ReleaseDEXE.props         |   20 +
 builds/msvc/properties/ReleaseDLL.props          |   19 +
 builds/msvc/properties/ReleaseLEXE.props         |   20 +
 builds/msvc/properties/ReleaseLIB.props          |   19 +
 builds/msvc/properties/ReleaseLTCG.props         |   19 +
 builds/msvc/properties/ReleaseSEXE.props         |   20 +
 builds/msvc/properties/Win32.props               |   20 +
 builds/msvc/properties/x64.props                 |   23 +
 builds/msvc/readme.txt                           |   14 +
 builds/msvc/resource.h                           |   14 +
 builds/msvc/resource.rc                          |  Bin 0 -> 4642 bytes
 builds/msvc/vs2008/inproc_lat/inproc_lat.vcproj  |   52 +
 builds/msvc/vs2008/inproc_thr/inproc_thr.vcproj  |   52 +
 builds/msvc/vs2008/libzmq.sln                    |   95 ++
 builds/msvc/vs2008/libzmq/libzmq.vcproj          |  263 +++++
 builds/msvc/vs2008/local_lat/local_lat.vcproj    |   52 +
 builds/msvc/vs2008/local_thr/local_thr.vcproj    |   52 +
 builds/msvc/vs2008/remote_lat/remote_lat.vcproj  |   52 +
 builds/msvc/vs2008/remote_thr/remote_thr.vcproj  |   52 +
 builds/msvc/vs2010/inproc_lat/inproc_lat.props   |   48 +
 builds/msvc/vs2010/inproc_lat/inproc_lat.vcxproj |   79 ++
 builds/msvc/vs2010/inproc_thr/inproc_thr.props   |   48 +
 builds/msvc/vs2010/inproc_thr/inproc_thr.vcxproj |   79 ++
 builds/msvc/vs2010/libsodium.import.props        |   52 +
 builds/msvc/vs2010/libsodium.import.xml          |   17 +
 builds/msvc/vs2010/libzmq.import.props           |   66 ++
 builds/msvc/vs2010/libzmq.import.xml             |   38 +
 builds/msvc/vs2010/libzmq.sln                    |  206 ++++
 builds/msvc/vs2010/libzmq/libzmq.props           |   69 ++
 builds/msvc/vs2010/libzmq/libzmq.vcxproj         |  250 ++++
 builds/msvc/vs2010/libzmq/libzmq.vcxproj.filters |  540 +++++++++
 builds/msvc/vs2010/libzmq/libzmq.xml             |   25 +
 builds/msvc/vs2010/local_lat/local_lat.props     |   48 +
 builds/msvc/vs2010/local_lat/local_lat.vcxproj   |   79 ++
 builds/msvc/vs2010/local_thr/local_thr.props     |   48 +
 builds/msvc/vs2010/local_thr/local_thr.vcxproj   |   83 ++
 builds/msvc/vs2010/remote_lat/remote_lat.props   |   48 +
 builds/msvc/vs2010/remote_lat/remote_lat.vcxproj |   83 ++
 builds/msvc/vs2010/remote_thr/remote_thr.props   |   48 +
 builds/msvc/vs2010/remote_thr/remote_thr.vcxproj |   79 ++
 builds/msvc/vs2012/inproc_lat/inproc_lat.props   |   48 +
 builds/msvc/vs2012/inproc_lat/inproc_lat.vcxproj |   79 ++
 builds/msvc/vs2012/inproc_thr/inproc_thr.props   |   48 +
 builds/msvc/vs2012/inproc_thr/inproc_thr.vcxproj |   79 ++
 builds/msvc/vs2012/libsodium.import.props        |   52 +
 builds/msvc/vs2012/libsodium.import.xml          |   17 +
 builds/msvc/vs2012/libzmq.import.props           |   66 ++
 builds/msvc/vs2012/libzmq.import.xml             |   38 +
 builds/msvc/vs2012/libzmq.sln                    |  206 ++++
 builds/msvc/vs2012/libzmq/libzmq.props           |   69 ++
 builds/msvc/vs2012/libzmq/libzmq.vcxproj         |  250 ++++
 builds/msvc/vs2012/libzmq/libzmq.vcxproj.filters |  540 +++++++++
 builds/msvc/vs2012/libzmq/libzmq.xml             |   25 +
 builds/msvc/vs2012/local_lat/local_lat.props     |   48 +
 builds/msvc/vs2012/local_lat/local_lat.vcxproj   |   79 ++
 builds/msvc/vs2012/local_thr/local_thr.props     |   48 +
 builds/msvc/vs2012/local_thr/local_thr.vcxproj   |   83 ++
 builds/msvc/vs2012/remote_lat/remote_lat.props   |   48 +
 builds/msvc/vs2012/remote_lat/remote_lat.vcxproj |   83 ++
 builds/msvc/vs2012/remote_thr/remote_thr.props   |   48 +
 builds/msvc/vs2012/remote_thr/remote_thr.vcxproj |   79 ++
 builds/msvc/vs2013/inproc_lat/inproc_lat.props   |   48 +
 builds/msvc/vs2013/inproc_lat/inproc_lat.vcxproj |   79 ++
 builds/msvc/vs2013/inproc_thr/inproc_thr.props   |   48 +
 builds/msvc/vs2013/inproc_thr/inproc_thr.vcxproj |   79 ++
 builds/msvc/vs2013/libsodium.import.props        |   52 +
 builds/msvc/vs2013/libsodium.import.xml          |   17 +
 builds/msvc/vs2013/libzmq.import.props           |   66 ++
 builds/msvc/vs2013/libzmq.import.xml             |   38 +
 builds/msvc/vs2013/libzmq.sln                    |  208 ++++
 builds/msvc/vs2013/libzmq/libzmq.props           |   69 ++
 builds/msvc/vs2013/libzmq/libzmq.vcxproj         |  250 ++++
 builds/msvc/vs2013/libzmq/libzmq.vcxproj.filters |  540 +++++++++
 builds/msvc/vs2013/libzmq/libzmq.xml             |   25 +
 builds/msvc/vs2013/local_lat/local_lat.props     |   48 +
 builds/msvc/vs2013/local_lat/local_lat.vcxproj   |   79 ++
 builds/msvc/vs2013/local_thr/local_thr.props     |   48 +
 builds/msvc/vs2013/local_thr/local_thr.vcxproj   |   83 ++
 builds/msvc/vs2013/remote_lat/remote_lat.props   |   48 +
 builds/msvc/vs2013/remote_lat/remote_lat.vcxproj |   83 ++
 builds/msvc/vs2013/remote_thr/remote_thr.props   |   48 +
 builds/msvc/vs2013/remote_thr/remote_thr.vcxproj |   79 ++
 builds/nuget/libzmq.autopkg                      |   52 +
 builds/nuget/readme.nuget                        |   20 +
 builds/redhat/zeromq.spec.in                     |  200 ++++
 builds/valgrind/valgrind.supp                    |   14 +
 builds/valgrind/vg                               |    1 +
 builds/zos/README.md                             |  463 ++++++++
 builds/zos/cxxall                                |   62 +
 builds/zos/makeclean                             |   36 +
 builds/zos/makelibzmq                            |   54 +
 builds/zos/maketests                             |  102 ++
 builds/zos/platform.hpp                          |  300 +++++
 builds/zos/runtests                              |  188 +++
 builds/zos/test_fork.cpp                         |   95 ++
 builds/zos/zc++                                  |   42 +
 configure.ac                                     |  542 +++++++++
 doc/Makefile.am                                  |   54 +
 doc/asciidoc.conf                                |   56 +
 doc/zmq.txt                                      |  253 ++++
 doc/zmq_bind.txt                                 |  102 ++
 doc/zmq_close.txt                                |   52 +
 doc/zmq_connect.txt                              |  100 ++
 doc/zmq_ctx_destroy.txt                          |   67 ++
 doc/zmq_ctx_get.txt                              |   77 ++
 doc/zmq_ctx_new.txt                              |   50 +
 doc/zmq_ctx_set.txt                              |  110 ++
 doc/zmq_ctx_shutdown.txt                         |   52 +
 doc/zmq_ctx_term.txt                             |   76 ++
 doc/zmq_curve.txt                                |   92 ++
 doc/zmq_curve_keypair.txt                        |   56 +
 doc/zmq_disconnect.txt                           |   75 ++
 doc/zmq_errno.txt                                |   50 +
 doc/zmq_getsockopt.txt                           |  723 ++++++++++++
 doc/zmq_gssapi.txt                               |   57 +
 doc/zmq_has.txt                                  |   43 +
 doc/zmq_init.txt                                 |   52 +
 doc/zmq_inproc.txt                               |   85 ++
 doc/zmq_ipc.txt                                  |  105 ++
 doc/zmq_msg_close.txt                            |   56 +
 doc/zmq_msg_copy.txt                             |   72 ++
 doc/zmq_msg_data.txt                             |   48 +
 doc/zmq_msg_get.txt                              |   83 ++
 doc/zmq_msg_gets.txt                             |   75 ++
 doc/zmq_msg_init.txt                             |   64 +
 doc/zmq_msg_init_data.txt                        |   89 ++
 doc/zmq_msg_init_size.txt                        |   58 +
 doc/zmq_msg_more.txt                             |   65 ++
 doc/zmq_msg_move.txt                             |   52 +
 doc/zmq_msg_recv.txt                             |  124 ++
 doc/zmq_msg_send.txt                             |  125 ++
 doc/zmq_msg_set.txt                              |   46 +
 doc/zmq_msg_size.txt                             |   48 +
 doc/zmq_null.txt                                 |   27 +
 doc/zmq_pgm.txt                                  |  163 +++
 doc/zmq_plain.txt                                |   37 +
 doc/zmq_poll.txt                                 |  128 ++
 doc/zmq_proxy.txt                                |   98 ++
 doc/zmq_proxy_steerable.txt                      |   98 ++
 doc/zmq_recv.txt                                 |   90 ++
 doc/zmq_recvmsg.txt                              |  121 ++
 doc/zmq_send.txt                                 |  102 ++
 doc/zmq_send_const.txt                           |  103 ++
 doc/zmq_sendmsg.txt                              |  119 ++
 doc/zmq_setsockopt.txt                           |  956 +++++++++++++++
 doc/zmq_socket.txt                               |  455 ++++++++
 doc/zmq_socket_monitor.txt                       |  239 ++++
 doc/zmq_strerror.txt                             |   56 +
 doc/zmq_tcp.txt                                  |  117 ++
 doc/zmq_term.txt                                 |   66 ++
 doc/zmq_tipc.txt                                 |   82 ++
 doc/zmq_unbind.txt                               |   88 ++
 doc/zmq_version.txt                              |   54 +
 doc/zmq_z85_decode.txt                           |   50 +
 doc/zmq_z85_encode.txt                           |   57 +
 include/zmq.h                                    |  463 ++++++++
 include/zmq_utils.h                              |   20 +
 installer.ico                                    |  Bin 0 -> 2842 bytes
 packaging/nuget/package.bat                      |   13 +
 packaging/nuget/package.config                   |    6 +
 packaging/nuget/package.gsl                      |  265 +++++
 packaging/nuget/package.nuspec                   |   99 ++
 packaging/nuget/package.targets                  |  130 +++
 packaging/nuget/package.xml                      |   22 +
 perf/inproc_lat.cpp                              |  241 ++++
 perf/inproc_thr.cpp                              |  251 ++++
 perf/local_lat.cpp                               |  117 ++
 perf/local_thr.cpp                               |  141 +++
 perf/remote_lat.cpp                              |  130 +++
 perf/remote_thr.cpp                              |  108 ++
 src/address.cpp                                  |  105 ++
 src/address.hpp                                  |   67 ++
 src/array.hpp                                    |  163 +++
 src/atomic_counter.hpp                           |  215 ++++
 src/atomic_ptr.hpp                               |  212 ++++
 src/blob.hpp                                     |  139 +++
 src/clock.cpp                                    |  210 ++++
 src/clock.hpp                                    |   69 ++
 src/command.hpp                                  |  163 +++
 src/config.hpp                                   |   97 ++
 src/ctx.cpp                                      |  567 +++++++++
 src/ctx.hpp                                      |  223 ++++
 src/curve_client.cpp                             |  460 ++++++++
 src/curve_client.hpp                             |  129 +++
 src/curve_server.cpp                             |  730 ++++++++++++
 src/curve_server.hpp                             |  138 +++
 src/dbuffer.hpp                                  |  144 +++
 src/dealer.cpp                                   |  141 +++
 src/dealer.hpp                                   |   89 ++
 src/decoder.hpp                                  |  183 +++
 src/devpoll.cpp                                  |  204 ++++
 src/devpoll.hpp                                  |  119 ++
 src/dist.cpp                                     |  216 ++++
 src/dist.hpp                                     |  117 ++
 src/encoder.hpp                                  |  185 +++
 src/epoll.cpp                                    |  192 +++
 src/epoll.hpp                                    |  115 ++
 src/err.cpp                                      |  386 +++++++
 src/err.hpp                                      |  168 +++
 src/fd.hpp                                       |   54 +
 src/fq.cpp                                       |  162 +++
 src/fq.hpp                                       |   92 ++
 src/gssapi_client.cpp                            |  230 ++++
 src/gssapi_client.hpp                            |   93 ++
 src/gssapi_mechanism_base.cpp                    |  347 ++++++
 src/gssapi_mechanism_base.hpp                    |  132 +++
 src/gssapi_server.cpp                            |  377 ++++++
 src/gssapi_server.hpp                            |   96 ++
 src/i_decoder.hpp                                |   61 +
 src/i_encoder.hpp                                |   60 +
 src/i_engine.hpp                                 |   65 ++
 src/i_poll_events.hpp                            |   55 +
 src/io_object.cpp                                |  116 ++
 src/io_object.hpp                                |   89 ++
 src/io_thread.cpp                                |  112 ++
 src/io_thread.hpp                                |   99 ++
 src/ip.cpp                                       |  176 +++
 src/ip.hpp                                       |   57 +
 src/ipc_address.cpp                              |  105 ++
 src/ipc_address.hpp                              |   76 ++
 src/ipc_connecter.cpp                            |  275 +++++
 src/ipc_connecter.hpp                            |  137 +++
 src/ipc_listener.cpp                             |  315 +++++
 src/ipc_listener.hpp                             |  114 ++
 src/kqueue.cpp                                   |  225 ++++
 src/kqueue.hpp                                   |  127 ++
 src/lb.cpp                                       |  160 +++
 src/lb.hpp                                       |   88 ++
 src/libzmq.pc.cmake.in                           |   10 +
 src/libzmq.pc.in                                 |   10 +
 src/libzmq.vers                                  |    4 +
 src/likely.hpp                                   |   42 +
 src/mailbox.cpp                                  |   96 ++
 src/mailbox.hpp                                  |   90 ++
 src/mechanism.cpp                                |  194 ++++
 src/mechanism.hpp                                |  139 +++
 src/metadata.cpp                                 |   59 +
 src/metadata.hpp                                 |   70 ++
 src/msg.cpp                                      |  389 +++++++
 src/msg.hpp                                      |  187 +++
 src/mtrie.cpp                                    |  440 +++++++
 src/mtrie.hpp                                    |  101 ++
 src/mutex.hpp                                    |  167 +++
 src/norm_engine.cpp                              |  728 ++++++++++++
 src/norm_engine.hpp                              |  188 +++
 src/null_mechanism.cpp                           |  358 ++++++
 src/null_mechanism.hpp                           |   84 ++
 src/object.cpp                                   |  437 +++++++
 src/object.hpp                                   |  152 +++
 src/options.cpp                                  |  864 ++++++++++++++
 src/options.hpp                                  |  195 ++++
 src/own.cpp                                      |  215 ++++
 src/own.hpp                                      |  154 +++
 src/pair.cpp                                     |  141 +++
 src/pair.hpp                                     |   78 ++
 src/pgm_receiver.cpp                             |  306 +++++
 src/pgm_receiver.hpp                             |  152 +++
 src/pgm_sender.cpp                               |  249 ++++
 src/pgm_sender.hpp                               |  129 +++
 src/pgm_socket.cpp                               |  716 ++++++++++++
 src/pgm_socket.hpp                               |  131 +++
 src/pipe.cpp                                     |  519 +++++++++
 src/pipe.hpp                                     |  233 ++++
 src/plain_client.cpp                             |  222 ++++
 src/plain_client.hpp                             |   79 ++
 src/plain_server.cpp                             |  440 +++++++
 src/plain_server.hpp                             |   93 ++
 src/poll.cpp                                     |  190 +++
 src/poll.hpp                                     |  119 ++
 src/poller.hpp                                   |   61 +
 src/poller_base.cpp                              |  109 ++
 src/poller_base.hpp                              |   95 ++
 src/precompiled.cpp                              |   30 +
 src/precompiled.hpp                              |   56 +
 src/proxy.cpp                                    |  203 ++++
 src/proxy.hpp                                    |   42 +
 src/pub.cpp                                      |   66 ++
 src/pub.hpp                                      |   63 +
 src/pull.cpp                                     |   77 ++
 src/pull.hpp                                     |   75 ++
 src/push.cpp                                     |   75 ++
 src/push.hpp                                     |   73 ++
 src/random.cpp                                   |   61 +
 src/random.hpp                                   |   46 +
 src/raw_decoder.cpp                              |   73 ++
 src/raw_decoder.hpp                              |   76 ++
 src/raw_encoder.cpp                              |   50 +
 src/raw_encoder.hpp                              |   70 ++
 src/reaper.cpp                                   |  137 +++
 src/reaper.hpp                                   |   94 ++
 src/rep.cpp                                      |  133 +++
 src/rep.hpp                                      |   73 ++
 src/req.cpp                                      |  289 +++++
 src/req.hpp                                      |  120 ++
 src/router.cpp                                   |  479 ++++++++
 src/router.hpp                                   |  140 +++
 src/select.cpp                                   |  234 ++++
 src/select.hpp                                   |  140 +++
 src/session_base.cpp                             |  627 ++++++++++
 src/session_base.hpp                             |  172 +++
 src/signaler.cpp                                 |  568 +++++++++
 src/signaler.hpp                                 |   90 ++
 src/socket_base.cpp                              | 1346 ++++++++++++++++++++++
 src/socket_base.hpp                              |  278 +++++
 src/socks.cpp                                    |  283 +++++
 src/socks.hpp                                    |  135 +++
 src/socks_connecter.cpp                          |  478 ++++++++
 src/socks_connecter.hpp                          |  164 +++
 src/stdint.hpp                                   |   72 ++
 src/stream.cpp                                   |  307 +++++
 src/stream.hpp                                   |  107 ++
 src/stream_engine.cpp                            |  960 +++++++++++++++
 src/stream_engine.hpp                            |  218 ++++
 src/sub.cpp                                      |   90 ++
 src/sub.hpp                                      |   64 +
 src/tcp.cpp                                      |  252 ++++
 src/tcp.hpp                                      |   62 +
 src/tcp_address.cpp                              |  694 +++++++++++
 src/tcp_address.hpp                              |  116 ++
 src/tcp_connecter.cpp                            |  367 ++++++
 src/tcp_connecter.hpp                            |  131 +++
 src/tcp_listener.cpp                             |  333 ++++++
 src/tcp_listener.hpp                             |   99 ++
 src/thread.cpp                                   |  144 +++
 src/thread.hpp                                   |   91 ++
 src/tipc_address.cpp                             |  117 ++
 src/tipc_address.hpp                             |   75 ++
 src/tipc_connecter.cpp                           |  266 +++++
 src/tipc_connecter.hpp                           |  137 +++
 src/tipc_listener.cpp                            |  188 +++
 src/tipc_listener.hpp                            |  107 ++
 src/trie.cpp                                     |  344 ++++++
 src/trie.hpp                                     |   86 ++
 src/v1_decoder.cpp                               |  158 +++
 src/v1_decoder.hpp                               |   67 ++
 src/v1_encoder.cpp                               |   75 ++
 src/v1_encoder.hpp                               |   59 +
 src/v2_decoder.cpp                               |  152 +++
 src/v2_decoder.hpp                               |   67 ++
 src/v2_encoder.cpp                               |   77 ++
 src/v2_encoder.hpp                               |   59 +
 src/v2_protocol.hpp                              |   49 +
 src/version.rc.in                                |   93 ++
 src/windows.hpp                                  |   84 ++
 src/wire.hpp                                     |  108 ++
 src/xpub.cpp                                     |  207 ++++
 src/xpub.hpp                                     |  107 ++
 src/xsub.cpp                                     |  243 ++++
 src/xsub.hpp                                     |  103 ++
 src/ypipe.hpp                                    |  219 ++++
 src/ypipe_base.hpp                               |   54 +
 src/ypipe_conflate.hpp                           |  137 +++
 src/yqueue.hpp                                   |  205 ++++
 src/zmq.cpp                                      | 1095 ++++++++++++++++++
 src/zmq_utils.cpp                                |  216 ++++
 tests/CMakeLists.txt                             |   86 ++
 tests/test_abstract_ipc.cpp                      |   67 ++
 tests/test_bind_src_address.cpp                  |   57 +
 tests/test_capabilities.cpp                      |   71 ++
 tests/test_conflate.cpp                          |   82 ++
 tests/test_connect_delay_tipc.cpp                |  248 ++++
 tests/test_connect_resolve.cpp                   |   70 ++
 tests/test_connect_rid.cpp                       |  194 ++++
 tests/test_ctx_destroy.cpp                       |  100 ++
 tests/test_ctx_options.cpp                       |   69 ++
 tests/test_diffserv.cpp                          |   80 ++
 tests/test_disconnect_inproc.cpp                 |  135 +++
 tests/test_filter_ipc.cpp                        |  171 +++
 tests/test_fork.cpp                              |   91 ++
 tests/test_getsockopt_memset.cpp                 |   69 ++
 tests/test_hwm.cpp                               |  309 +++++
 tests/test_hwm_pubsub.cpp                        |  171 +++
 tests/test_id2fd.cpp                             |   97 ++
 tests/test_immediate.cpp                         |  238 ++++
 tests/test_inproc_connect.cpp                    |  489 ++++++++
 tests/test_invalid_rep.cpp                       |   98 ++
 tests/test_iov.cpp                               |  116 ++
 tests/test_ipc_wildcard.cpp                      |   65 ++
 tests/test_issue_566.cpp                         |   95 ++
 tests/test_last_endpoint.cpp                     |   66 ++
 tests/test_many_sockets.cpp                      |  100 ++
 tests/test_metadata.cpp                          |  129 +++
 tests/test_monitor.cpp                           |  138 +++
 tests/test_msg_flags.cpp                         |  127 ++
 tests/test_pair_inproc.cpp                       |   81 ++
 tests/test_pair_ipc.cpp                          |   60 +
 tests/test_pair_tcp.cpp                          |   60 +
 tests/test_pair_tipc.cpp                         |   64 +
 tests/test_probe_router.cpp                      |   82 ++
 tests/test_proxy.cpp                             |  261 +++++
 tests/test_proxy_single_socket.cpp               |  113 ++
 tests/test_proxy_terminate.cpp                   |  123 ++
 tests/test_req_correlate.cpp                     |  187 +++
 tests/test_req_relaxed.cpp                       |  126 ++
 tests/test_reqrep_device.cpp                     |  145 +++
 tests/test_reqrep_device_tipc.cpp                |  153 +++
 tests/test_reqrep_inproc.cpp                     |   60 +
 tests/test_reqrep_ipc.cpp                        |   60 +
 tests/test_reqrep_tcp.cpp                        |   60 +
 tests/test_reqrep_tipc.cpp                       |   64 +
 tests/test_router_handover.cpp                   |  111 ++
 tests/test_router_mandatory.cpp                  |   91 ++
 tests/test_router_mandatory_hwm.cpp              |  126 ++
 tests/test_router_mandatory_tipc.cpp             |   72 ++
 tests/test_security_curve.cpp                    |  291 +++++
 tests/test_security_null.cpp                     |  187 +++
 tests/test_security_plain.cpp                    |  195 ++++
 tests/test_shutdown_stress.cpp                   |   90 ++
 tests/test_shutdown_stress_tipc.cpp              |  103 ++
 tests/test_spec_dealer.cpp                       |  264 +++++
 tests/test_spec_pushpull.cpp                     |  303 +++++
 tests/test_spec_rep.cpp                          |  165 +++
 tests/test_spec_req.cpp                          |  263 +++++
 tests/test_spec_router.cpp                       |  214 ++++
 tests/test_srcfd.cpp                             |  109 ++
 tests/test_stream.cpp                            |  292 +++++
 tests/test_stream_disconnect.cpp                 |  268 +++++
 tests/test_stream_empty.cpp                      |   70 ++
 tests/test_stream_timeout.cpp                    |  226 ++++
 tests/test_sub_forward.cpp                       |  101 ++
 tests/test_sub_forward_tipc.cpp                  |  111 ++
 tests/test_system.cpp                            |   99 ++
 tests/test_term_endpoint.cpp                     |  167 +++
 tests/test_term_endpoint_tipc.cpp                |  130 +++
 tests/test_timeo.cpp                             |   85 ++
 tests/test_unbind_inproc.cpp                     |   43 +
 tests/test_unbind_wildcard.cpp                   |   48 +
 tests/test_xpub_nodrop.cpp                       |  116 ++
 tests/testutil.hpp                               |  303 +++++
 tools/curve_keygen.cpp                           |   58 +
 tweetnacl/contrib/randombytes/devurandom.c       |   44 +
 tweetnacl/contrib/randombytes/randombytes.h      |   21 +
 tweetnacl/contrib/randombytes/winrandom.c        |   43 +
 tweetnacl/src/tweetnacl.c                        |  818 +++++++++++++
 tweetnacl/src/tweetnacl.h                        |  273 +++++
 tweetnacl/src/tweetnacl_base.h                   |   41 +
 version.sh                                       |   21 +
 483 files changed, 72975 insertions(+)

commit 6933dfff58881c4c98a1e38e2c3689ac2874f39d
Author: Pieter Hintjens <ph@imatix.com>
Date:   Thu Jan 14 15:15:55 2016 +0100

    Merge pull request #87 from GreatFruitOmsk/master
    
    Backport #1702

 .gitignore                                       |  148 +++
 .hgeol                                           |    2 +
 .travis.yml                                      |   35 +
 AUTHORS                                          |  138 +++
 CMakeLists.txt                                   |  861 ++++++++++++++
 COPYING                                          |  674 +++++++++++
 COPYING.LESSER                                   |  181 +++
 Dockerfile                                       |   11 +
 INSTALL                                          |  246 ++++
 MAINTAINERS                                      |   56 +
 Makefile.am                                      |  637 ++++++++++
 NEWS                                             | 1066 +++++++++++++++++
 README.md                                        |   55 +
 acinclude.m4                                     |  930 +++++++++++++++
 autogen.sh                                       |   49 +
 branding.bmp                                     |  Bin 0 -> 25818 bytes
 builds/cmake/Modules/FindAsciiDoc.cmake          |   27 +
 builds/cmake/Modules/TestZMQVersion.cmake        |    9 +
 builds/cmake/Modules/ZMQSourceRunChecks.cmake    |  129 +++
 builds/cmake/NSIS.template32.in                  |  952 +++++++++++++++
 builds/cmake/NSIS.template64.in                  |  960 +++++++++++++++
 builds/cmake/platform.hpp.in                     |   90 ++
 builds/mingw32/Makefile.mingw32                  |   47 +
 builds/mingw32/platform.hpp                      |   41 +
 builds/msvc/Makefile.am                          |  103 ++
 builds/msvc/build/buildall.bat                   |   10 +
 builds/msvc/build/buildbase.bat                  |   69 ++
 builds/msvc/errno.cpp                            |   32 +
 builds/msvc/errno.hpp                            |   56 +
 builds/msvc/platform.hpp                         |   41 +
 builds/msvc/properties/Common.props              |   21 +
 builds/msvc/properties/DLL.props                 |   16 +
 builds/msvc/properties/Debug.props               |   29 +
 builds/msvc/properties/DebugDEXE.props           |   21 +
 builds/msvc/properties/DebugDLL.props            |   20 +
 builds/msvc/properties/DebugLEXE.props           |   20 +
 builds/msvc/properties/DebugLIB.props            |   21 +
 builds/msvc/properties/DebugLTCG.props           |   20 +
 builds/msvc/properties/DebugSEXE.props           |   21 +
 builds/msvc/properties/EXE.props                 |   17 +
 builds/msvc/properties/LIB.props                 |   16 +
 builds/msvc/properties/LTCG.props                |   13 +
 builds/msvc/properties/Link.props                |   21 +
 builds/msvc/properties/Messages.props            |   15 +
 builds/msvc/properties/Output.props              |   30 +
 builds/msvc/properties/Release.props             |   41 +
 builds/msvc/properties/ReleaseDEXE.props         |   20 +
 builds/msvc/properties/ReleaseDLL.props          |   19 +
 builds/msvc/properties/ReleaseLEXE.props         |   20 +
 builds/msvc/properties/ReleaseLIB.props          |   19 +
 builds/msvc/properties/ReleaseLTCG.props         |   19 +
 builds/msvc/properties/ReleaseSEXE.props         |   20 +
 builds/msvc/properties/Win32.props               |   20 +
 builds/msvc/properties/x64.props                 |   23 +
 builds/msvc/readme.txt                           |   14 +
 builds/msvc/resource.h                           |   14 +
 builds/msvc/resource.rc                          |  Bin 0 -> 4642 bytes
 builds/msvc/vs2008/inproc_lat/inproc_lat.vcproj  |   52 +
 builds/msvc/vs2008/inproc_thr/inproc_thr.vcproj  |   52 +
 builds/msvc/vs2008/libzmq.sln                    |   95 ++
 builds/msvc/vs2008/libzmq/libzmq.vcproj          |  263 +++++
 builds/msvc/vs2008/local_lat/local_lat.vcproj    |   52 +
 builds/msvc/vs2008/local_thr/local_thr.vcproj    |   52 +
 builds/msvc/vs2008/remote_lat/remote_lat.vcproj  |   52 +
 builds/msvc/vs2008/remote_thr/remote_thr.vcproj  |   52 +
 builds/msvc/vs2010/inproc_lat/inproc_lat.props   |   48 +
 builds/msvc/vs2010/inproc_lat/inproc_lat.vcxproj |   79 ++
 builds/msvc/vs2010/inproc_thr/inproc_thr.props   |   48 +
 builds/msvc/vs2010/inproc_thr/inproc_thr.vcxproj |   79 ++
 builds/msvc/vs2010/libsodium.import.props        |   52 +
 builds/msvc/vs2010/libsodium.import.xml          |   17 +
 builds/msvc/vs2010/libzmq.import.props           |   66 ++
 builds/msvc/vs2010/libzmq.import.xml             |   38 +
 builds/msvc/vs2010/libzmq.sln                    |  206 ++++
 builds/msvc/vs2010/libzmq/libzmq.props           |   69 ++
 builds/msvc/vs2010/libzmq/libzmq.vcxproj         |  250 ++++
 builds/msvc/vs2010/libzmq/libzmq.vcxproj.filters |  540 +++++++++
 builds/msvc/vs2010/libzmq/libzmq.xml             |   25 +
 builds/msvc/vs2010/local_lat/local_lat.props     |   48 +
 builds/msvc/vs2010/local_lat/local_lat.vcxproj   |   79 ++
 builds/msvc/vs2010/local_thr/local_thr.props     |   48 +
 builds/msvc/vs2010/local_thr/local_thr.vcxproj   |   83 ++
 builds/msvc/vs2010/remote_lat/remote_lat.props   |   48 +
 builds/msvc/vs2010/remote_lat/remote_lat.vcxproj |   83 ++
 builds/msvc/vs2010/remote_thr/remote_thr.props   |   48 +
 builds/msvc/vs2010/remote_thr/remote_thr.vcxproj |   79 ++
 builds/msvc/vs2012/inproc_lat/inproc_lat.props   |   48 +
 builds/msvc/vs2012/inproc_lat/inproc_lat.vcxproj |   79 ++
 builds/msvc/vs2012/inproc_thr/inproc_thr.props   |   48 +
 builds/msvc/vs2012/inproc_thr/inproc_thr.vcxproj |   79 ++
 builds/msvc/vs2012/libsodium.import.props        |   52 +
 builds/msvc/vs2012/libsodium.import.xml          |   17 +
 builds/msvc/vs2012/libzmq.import.props           |   66 ++
 builds/msvc/vs2012/libzmq.import.xml             |   38 +
 builds/msvc/vs2012/libzmq.sln                    |  206 ++++
 builds/msvc/vs2012/libzmq/libzmq.props           |   69 ++
 builds/msvc/vs2012/libzmq/libzmq.vcxproj         |  250 ++++
 builds/msvc/vs2012/libzmq/libzmq.vcxproj.filters |  540 +++++++++
 builds/msvc/vs2012/libzmq/libzmq.xml             |   25 +
 builds/msvc/vs2012/local_lat/local_lat.props     |   48 +
 builds/msvc/vs2012/local_lat/local_lat.vcxproj   |   79 ++
 builds/msvc/vs2012/local_thr/local_thr.props     |   48 +
 builds/msvc/vs2012/local_thr/local_thr.vcxproj   |   83 ++
 builds/msvc/vs2012/remote_lat/remote_lat.props   |   48 +
 builds/msvc/vs2012/remote_lat/remote_lat.vcxproj |   83 ++
 builds/msvc/vs2012/remote_thr/remote_thr.props   |   48 +
 builds/msvc/vs2012/remote_thr/remote_thr.vcxproj |   79 ++
 builds/msvc/vs2013/inproc_lat/inproc_lat.props   |   48 +
 builds/msvc/vs2013/inproc_lat/inproc_lat.vcxproj |   79 ++
 builds/msvc/vs2013/inproc_thr/inproc_thr.props   |   48 +
 builds/msvc/vs2013/inproc_thr/inproc_thr.vcxproj |   79 ++
 builds/msvc/vs2013/libsodium.import.props        |   52 +
 builds/msvc/vs2013/libsodium.import.xml          |   17 +
 builds/msvc/vs2013/libzmq.import.props           |   66 ++
 builds/msvc/vs2013/libzmq.import.xml             |   38 +
 builds/msvc/vs2013/libzmq.sln                    |  208 ++++
 builds/msvc/vs2013/libzmq/libzmq.props           |   69 ++
 builds/msvc/vs2013/libzmq/libzmq.vcxproj         |  250 ++++
 builds/msvc/vs2013/libzmq/libzmq.vcxproj.filters |  540 +++++++++
 builds/msvc/vs2013/libzmq/libzmq.xml             |   25 +
 builds/msvc/vs2013/local_lat/local_lat.props     |   48 +
 builds/msvc/vs2013/local_lat/local_lat.vcxproj   |   79 ++
 builds/msvc/vs2013/local_thr/local_thr.props     |   48 +
 builds/msvc/vs2013/local_thr/local_thr.vcxproj   |   83 ++
 builds/msvc/vs2013/remote_lat/remote_lat.props   |   48 +
 builds/msvc/vs2013/remote_lat/remote_lat.vcxproj |   83 ++
 builds/msvc/vs2013/remote_thr/remote_thr.props   |   48 +
 builds/msvc/vs2013/remote_thr/remote_thr.vcxproj |   79 ++
 builds/nuget/libzmq.autopkg                      |   52 +
 builds/nuget/readme.nuget                        |   20 +
 builds/redhat/zeromq.spec.in                     |  200 ++++
 builds/valgrind/valgrind.supp                    |   14 +
 builds/valgrind/vg                               |    1 +
 builds/zos/README.md                             |  463 ++++++++
 builds/zos/cxxall                                |   62 +
 builds/zos/makeclean                             |   36 +
 builds/zos/makelibzmq                            |   54 +
 builds/zos/maketests                             |  102 ++
 builds/zos/platform.hpp                          |  300 +++++
 builds/zos/runtests                              |  188 +++
 builds/zos/test_fork.cpp                         |   95 ++
 builds/zos/zc++                                  |   42 +
 configure.ac                                     |  542 +++++++++
 doc/Makefile.am                                  |   54 +
 doc/asciidoc.conf                                |   56 +
 doc/zmq.txt                                      |  253 ++++
 doc/zmq_bind.txt                                 |  102 ++
 doc/zmq_close.txt                                |   52 +
 doc/zmq_connect.txt                              |  100 ++
 doc/zmq_ctx_destroy.txt                          |   67 ++
 doc/zmq_ctx_get.txt                              |   77 ++
 doc/zmq_ctx_new.txt                              |   50 +
 doc/zmq_ctx_set.txt                              |  110 ++
 doc/zmq_ctx_shutdown.txt                         |   52 +
 doc/zmq_ctx_term.txt                             |   76 ++
 doc/zmq_curve.txt                                |   92 ++
 doc/zmq_curve_keypair.txt                        |   56 +
 doc/zmq_disconnect.txt                           |   75 ++
 doc/zmq_errno.txt                                |   50 +
 doc/zmq_getsockopt.txt                           |  723 ++++++++++++
 doc/zmq_gssapi.txt                               |   57 +
 doc/zmq_has.txt                                  |   43 +
 doc/zmq_init.txt                                 |   52 +
 doc/zmq_inproc.txt                               |   85 ++
 doc/zmq_ipc.txt                                  |  105 ++
 doc/zmq_msg_close.txt                            |   56 +
 doc/zmq_msg_copy.txt                             |   72 ++
 doc/zmq_msg_data.txt                             |   48 +
 doc/zmq_msg_get.txt                              |   83 ++
 doc/zmq_msg_gets.txt                             |   75 ++
 doc/zmq_msg_init.txt                             |   64 +
 doc/zmq_msg_init_data.txt                        |   89 ++
 doc/zmq_msg_init_size.txt                        |   58 +
 doc/zmq_msg_more.txt                             |   65 ++
 doc/zmq_msg_move.txt                             |   52 +
 doc/zmq_msg_recv.txt                             |  124 ++
 doc/zmq_msg_send.txt                             |  125 ++
 doc/zmq_msg_set.txt                              |   46 +
 doc/zmq_msg_size.txt                             |   48 +
 doc/zmq_null.txt                                 |   27 +
 doc/zmq_pgm.txt                                  |  163 +++
 doc/zmq_plain.txt                                |   37 +
 doc/zmq_poll.txt                                 |  128 ++
 doc/zmq_proxy.txt                                |   98 ++
 doc/zmq_proxy_steerable.txt                      |   98 ++
 doc/zmq_recv.txt                                 |   90 ++
 doc/zmq_recvmsg.txt                              |  121 ++
 doc/zmq_send.txt                                 |  102 ++
 doc/zmq_send_const.txt                           |  103 ++
 doc/zmq_sendmsg.txt                              |  119 ++
 doc/zmq_setsockopt.txt                           |  956 +++++++++++++++
 doc/zmq_socket.txt                               |  455 ++++++++
 doc/zmq_socket_monitor.txt                       |  239 ++++
 doc/zmq_strerror.txt                             |   56 +
 doc/zmq_tcp.txt                                  |  117 ++
 doc/zmq_term.txt                                 |   66 ++
 doc/zmq_tipc.txt                                 |   82 ++
 doc/zmq_unbind.txt                               |   88 ++
 doc/zmq_version.txt                              |   54 +
 doc/zmq_z85_decode.txt                           |   50 +
 doc/zmq_z85_encode.txt                           |   57 +
 include/zmq.h                                    |  463 ++++++++
 include/zmq_utils.h                              |   20 +
 installer.ico                                    |  Bin 0 -> 2842 bytes
 packaging/nuget/package.bat                      |   13 +
 packaging/nuget/package.config                   |    6 +
 packaging/nuget/package.gsl                      |  265 +++++
 packaging/nuget/package.nuspec                   |   99 ++
 packaging/nuget/package.targets                  |  130 +++
 packaging/nuget/package.xml                      |   22 +
 perf/inproc_lat.cpp                              |  241 ++++
 perf/inproc_thr.cpp                              |  251 ++++
 perf/local_lat.cpp                               |  117 ++
 perf/local_thr.cpp                               |  141 +++
 perf/remote_lat.cpp                              |  130 +++
 perf/remote_thr.cpp                              |  108 ++
 src/address.cpp                                  |  105 ++
 src/address.hpp                                  |   67 ++
 src/array.hpp                                    |  163 +++
 src/atomic_counter.hpp                           |  215 ++++
 src/atomic_ptr.hpp                               |  212 ++++
 src/blob.hpp                                     |  139 +++
 src/clock.cpp                                    |  210 ++++
 src/clock.hpp                                    |   69 ++
 src/command.hpp                                  |  163 +++
 src/config.hpp                                   |   97 ++
 src/ctx.cpp                                      |  567 +++++++++
 src/ctx.hpp                                      |  223 ++++
 src/curve_client.cpp                             |  460 ++++++++
 src/curve_client.hpp                             |  129 +++
 src/curve_server.cpp                             |  730 ++++++++++++
 src/curve_server.hpp                             |  138 +++
 src/dbuffer.hpp                                  |  144 +++
 src/dealer.cpp                                   |  141 +++
 src/dealer.hpp                                   |   89 ++
 src/decoder.hpp                                  |  183 +++
 src/devpoll.cpp                                  |  204 ++++
 src/devpoll.hpp                                  |  119 ++
 src/dist.cpp                                     |  216 ++++
 src/dist.hpp                                     |  117 ++
 src/encoder.hpp                                  |  185 +++
 src/epoll.cpp                                    |  192 +++
 src/epoll.hpp                                    |  115 ++
 src/err.cpp                                      |  386 +++++++
 src/err.hpp                                      |  168 +++
 src/fd.hpp                                       |   54 +
 src/fq.cpp                                       |  162 +++
 src/fq.hpp                                       |   92 ++
 src/gssapi_client.cpp                            |  230 ++++
 src/gssapi_client.hpp                            |   93 ++
 src/gssapi_mechanism_base.cpp                    |  347 ++++++
 src/gssapi_mechanism_base.hpp                    |  132 +++
 src/gssapi_server.cpp                            |  377 ++++++
 src/gssapi_server.hpp                            |   96 ++
 src/i_decoder.hpp                                |   61 +
 src/i_encoder.hpp                                |   60 +
 src/i_engine.hpp                                 |   65 ++
 src/i_poll_events.hpp                            |   55 +
 src/io_object.cpp                                |  116 ++
 src/io_object.hpp                                |   89 ++
 src/io_thread.cpp                                |  112 ++
 src/io_thread.hpp                                |   99 ++
 src/ip.cpp                                       |  176 +++
 src/ip.hpp                                       |   57 +
 src/ipc_address.cpp                              |  105 ++
 src/ipc_address.hpp                              |   76 ++
 src/ipc_connecter.cpp                            |  275 +++++
 src/ipc_connecter.hpp                            |  137 +++
 src/ipc_listener.cpp                             |  315 +++++
 src/ipc_listener.hpp                             |  114 ++
 src/kqueue.cpp                                   |  225 ++++
 src/kqueue.hpp                                   |  127 ++
 src/lb.cpp                                       |  160 +++
 src/lb.hpp                                       |   88 ++
 src/libzmq.pc.cmake.in                           |   10 +
 src/libzmq.pc.in                                 |   10 +
 src/libzmq.vers                                  |    4 +
 src/likely.hpp                                   |   42 +
 src/mailbox.cpp                                  |   96 ++
 src/mailbox.hpp                                  |   90 ++
 src/mechanism.cpp                                |  194 ++++
 src/mechanism.hpp                                |  139 +++
 src/metadata.cpp                                 |   59 +
 src/metadata.hpp                                 |   70 ++
 src/msg.cpp                                      |  389 +++++++
 src/msg.hpp                                      |  187 +++
 src/mtrie.cpp                                    |  440 +++++++
 src/mtrie.hpp                                    |  101 ++
 src/mutex.hpp                                    |  167 +++
 src/norm_engine.cpp                              |  728 ++++++++++++
 src/norm_engine.hpp                              |  188 +++
 src/null_mechanism.cpp                           |  358 ++++++
 src/null_mechanism.hpp                           |   84 ++
 src/object.cpp                                   |  437 +++++++
 src/object.hpp                                   |  152 +++
 src/options.cpp                                  |  864 ++++++++++++++
 src/options.hpp                                  |  195 ++++
 src/own.cpp                                      |  215 ++++
 src/own.hpp                                      |  154 +++
 src/pair.cpp                                     |  141 +++
 src/pair.hpp                                     |   78 ++
 src/pgm_receiver.cpp                             |  306 +++++
 src/pgm_receiver.hpp                             |  152 +++
 src/pgm_sender.cpp                               |  249 ++++
 src/pgm_sender.hpp                               |  129 +++
 src/pgm_socket.cpp                               |  716 ++++++++++++
 src/pgm_socket.hpp                               |  131 +++
 src/pipe.cpp                                     |  519 +++++++++
 src/pipe.hpp                                     |  233 ++++
 src/plain_client.cpp                             |  222 ++++
 src/plain_client.hpp                             |   79 ++
 src/plain_server.cpp                             |  440 +++++++
 src/plain_server.hpp                             |   93 ++
 src/poll.cpp                                     |  190 +++
 src/poll.hpp                                     |  119 ++
 src/poller.hpp                                   |   61 +
 src/poller_base.cpp                              |  109 ++
 src/poller_base.hpp                              |   95 ++
 src/precompiled.cpp                              |   30 +
 src/precompiled.hpp                              |   56 +
 src/proxy.cpp                                    |  203 ++++
 src/proxy.hpp                                    |   42 +
 src/pub.cpp                                      |   66 ++
 src/pub.hpp                                      |   63 +
 src/pull.cpp                                     |   77 ++
 src/pull.hpp                                     |   75 ++
 src/push.cpp                                     |   75 ++
 src/push.hpp                                     |   73 ++
 src/random.cpp                                   |   61 +
 src/random.hpp                                   |   46 +
 src/raw_decoder.cpp                              |   73 ++
 src/raw_decoder.hpp                              |   76 ++
 src/raw_encoder.cpp                              |   50 +
 src/raw_encoder.hpp                              |   70 ++
 src/reaper.cpp                                   |  137 +++
 src/reaper.hpp                                   |   94 ++
 src/rep.cpp                                      |  133 +++
 src/rep.hpp                                      |   73 ++
 src/req.cpp                                      |  289 +++++
 src/req.hpp                                      |  120 ++
 src/router.cpp                                   |  479 ++++++++
 src/router.hpp                                   |  140 +++
 src/select.cpp                                   |  234 ++++
 src/select.hpp                                   |  140 +++
 src/session_base.cpp                             |  627 ++++++++++
 src/session_base.hpp                             |  172 +++
 src/signaler.cpp                                 |  568 +++++++++
 src/signaler.hpp                                 |   90 ++
 src/socket_base.cpp                              | 1346 ++++++++++++++++++++++
 src/socket_base.hpp                              |  278 +++++
 src/socks.cpp                                    |  283 +++++
 src/socks.hpp                                    |  135 +++
 src/socks_connecter.cpp                          |  478 ++++++++
 src/socks_connecter.hpp                          |  164 +++
 src/stdint.hpp                                   |   72 ++
 src/stream.cpp                                   |  307 +++++
 src/stream.hpp                                   |  107 ++
 src/stream_engine.cpp                            |  960 +++++++++++++++
 src/stream_engine.hpp                            |  218 ++++
 src/sub.cpp                                      |   90 ++
 src/sub.hpp                                      |   64 +
 src/tcp.cpp                                      |  252 ++++
 src/tcp.hpp                                      |   62 +
 src/tcp_address.cpp                              |  694 +++++++++++
 src/tcp_address.hpp                              |  116 ++
 src/tcp_connecter.cpp                            |  367 ++++++
 src/tcp_connecter.hpp                            |  131 +++
 src/tcp_listener.cpp                             |  333 ++++++
 src/tcp_listener.hpp                             |   99 ++
 src/thread.cpp                                   |  144 +++
 src/thread.hpp                                   |   91 ++
 src/tipc_address.cpp                             |  117 ++
 src/tipc_address.hpp                             |   75 ++
 src/tipc_connecter.cpp                           |  266 +++++
 src/tipc_connecter.hpp                           |  137 +++
 src/tipc_listener.cpp                            |  188 +++
 src/tipc_listener.hpp                            |  107 ++
 src/trie.cpp                                     |  344 ++++++
 src/trie.hpp                                     |   86 ++
 src/v1_decoder.cpp                               |  158 +++
 src/v1_decoder.hpp                               |   67 ++
 src/v1_encoder.cpp                               |   75 ++
 src/v1_encoder.hpp                               |   59 +
 src/v2_decoder.cpp                               |  152 +++
 src/v2_decoder.hpp                               |   67 ++
 src/v2_encoder.cpp                               |   77 ++
 src/v2_encoder.hpp                               |   59 +
 src/v2_protocol.hpp                              |   49 +
 src/version.rc.in                                |   93 ++
 src/windows.hpp                                  |   84 ++
 src/wire.hpp                                     |  108 ++
 src/xpub.cpp                                     |  207 ++++
 src/xpub.hpp                                     |  107 ++
 src/xsub.cpp                                     |  243 ++++
 src/xsub.hpp                                     |  103 ++
 src/ypipe.hpp                                    |  219 ++++
 src/ypipe_base.hpp                               |   54 +
 src/ypipe_conflate.hpp                           |  137 +++
 src/yqueue.hpp                                   |  205 ++++
 src/zmq.cpp                                      | 1095 ++++++++++++++++++
 src/zmq_utils.cpp                                |  216 ++++
 tests/CMakeLists.txt                             |   86 ++
 tests/test_abstract_ipc.cpp                      |   67 ++
 tests/test_bind_src_address.cpp                  |   57 +
 tests/test_capabilities.cpp                      |   71 ++
 tests/test_conflate.cpp                          |   82 ++
 tests/test_connect_delay_tipc.cpp                |  248 ++++
 tests/test_connect_resolve.cpp                   |   70 ++
 tests/test_connect_rid.cpp                       |  194 ++++
 tests/test_ctx_destroy.cpp                       |  100 ++
 tests/test_ctx_options.cpp                       |   69 ++
 tests/test_diffserv.cpp                          |   80 ++
 tests/test_disconnect_inproc.cpp                 |  135 +++
 tests/test_filter_ipc.cpp                        |  171 +++
 tests/test_fork.cpp                              |   91 ++
 tests/test_getsockopt_memset.cpp                 |   69 ++
 tests/test_hwm.cpp                               |  309 +++++
 tests/test_hwm_pubsub.cpp                        |  171 +++
 tests/test_id2fd.cpp                             |   97 ++
 tests/test_immediate.cpp                         |  238 ++++
 tests/test_inproc_connect.cpp                    |  489 ++++++++
 tests/test_invalid_rep.cpp                       |   98 ++
 tests/test_iov.cpp                               |  116 ++
 tests/test_ipc_wildcard.cpp                      |   65 ++
 tests/test_issue_566.cpp                         |   95 ++
 tests/test_last_endpoint.cpp                     |   66 ++
 tests/test_many_sockets.cpp                      |  100 ++
 tests/test_metadata.cpp                          |  129 +++
 tests/test_monitor.cpp                           |  138 +++
 tests/test_msg_flags.cpp                         |  127 ++
 tests/test_pair_inproc.cpp                       |   81 ++
 tests/test_pair_ipc.cpp                          |   60 +
 tests/test_pair_tcp.cpp                          |   60 +
 tests/test_pair_tipc.cpp                         |   64 +
 tests/test_probe_router.cpp                      |   82 ++
 tests/test_proxy.cpp                             |  261 +++++
 tests/test_proxy_single_socket.cpp               |  113 ++
 tests/test_proxy_terminate.cpp                   |  123 ++
 tests/test_req_correlate.cpp                     |  187 +++
 tests/test_req_relaxed.cpp                       |  126 ++
 tests/test_reqrep_device.cpp                     |  145 +++
 tests/test_reqrep_device_tipc.cpp                |  153 +++
 tests/test_reqrep_inproc.cpp                     |   60 +
 tests/test_reqrep_ipc.cpp                        |   60 +
 tests/test_reqrep_tcp.cpp                        |   60 +
 tests/test_reqrep_tipc.cpp                       |   64 +
 tests/test_router_handover.cpp                   |  111 ++
 tests/test_router_mandatory.cpp                  |   91 ++
 tests/test_router_mandatory_hwm.cpp              |  126 ++
 tests/test_router_mandatory_tipc.cpp             |   72 ++
 tests/test_security_curve.cpp                    |  291 +++++
 tests/test_security_null.cpp                     |  187 +++
 tests/test_security_plain.cpp                    |  195 ++++
 tests/test_shutdown_stress.cpp                   |   90 ++
 tests/test_shutdown_stress_tipc.cpp              |  103 ++
 tests/test_spec_dealer.cpp                       |  264 +++++
 tests/test_spec_pushpull.cpp                     |  303 +++++
 tests/test_spec_rep.cpp                          |  165 +++
 tests/test_spec_req.cpp                          |  263 +++++
 tests/test_spec_router.cpp                       |  214 ++++
 tests/test_srcfd.cpp                             |  109 ++
 tests/test_stream.cpp                            |  292 +++++
 tests/test_stream_disconnect.cpp                 |  268 +++++
 tests/test_stream_empty.cpp                      |   70 ++
 tests/test_stream_timeout.cpp                    |  226 ++++
 tests/test_sub_forward.cpp                       |  101 ++
 tests/test_sub_forward_tipc.cpp                  |  111 ++
 tests/test_system.cpp                            |   99 ++
 tests/test_term_endpoint.cpp                     |  167 +++
 tests/test_term_endpoint_tipc.cpp                |  130 +++
 tests/test_timeo.cpp                             |   85 ++
 tests/test_unbind_inproc.cpp                     |   43 +
 tests/test_unbind_wildcard.cpp                   |   48 +
 tests/test_xpub_nodrop.cpp                       |  116 ++
 tests/testutil.hpp                               |  303 +++++
 tools/curve_keygen.cpp                           |   58 +
 tweetnacl/contrib/randombytes/devurandom.c       |   44 +
 tweetnacl/contrib/randombytes/devurandom.h       |   25 +
 tweetnacl/contrib/randombytes/randombytes.h      |    5 +
 tweetnacl/src/tweetnacl.c                        |  818 +++++++++++++
 tweetnacl/src/tweetnacl.h                        |  273 +++++
 tweetnacl/src/tweetnacl_base.h                   |   41 +
 version.sh                                       |   21 +
 483 files changed, 72939 insertions(+)
